'From Squeak3.2 of 11 July 2002 [latest update: #4952] on 11 September 2002 at 6:05:32 pm'!
"Change Set:		B3DComments
Date:			26 August 2002
Author:			Boris Gaertner

This change set contains class comments for the more important classes of Balloon3D."!


!B3DAmbientLight commentStamp: '<historical>' prior: 0!
This is a light that has only a color. When this light is used, it colors the entire scene in a very special way: The ambient light has everywhere the same intensity. It is not recommended to add more than one ambient light to a scene.

Creation of an ambient light:

    ambientLight :=B3DAmbientLight new.
    ambientLight lightColor: (B3DMaterialColor color: (Color r: 0.0 g: 0.1 b: 0.0)).
    scene lights add: ambientLight.

!


!B3DDirectionalLight commentStamp: '<historical>' prior: 0!
This light has a color and a direction. The position of the light source is at infinity; the light rays are parallel. The intensity of such a light does not diminish with increasing distance. Three differently colored directional lights from different directions are often a good initial choice to color a scene with lights.

Creation of a directional light:

    light := B3DDirectionalLight new.
    light direction: 10 @ 0 @ 10.	
    light lightColor: (B3DMaterialColor color: (Color r: 0.1 g: 0.2 b: 0.0)).
    scene lights add: light.

!


!B3DGeometry commentStamp: '<historical>' prior: 0!
This is the superclass of all classes that represent geometric entites having a visible representation in a 3d scene.
Subclasses are required to implement the instance messages boundingBox, and renderOn:. It is desirable that subclasses implement also the transformation protocol of geometric objects.!


!B3DBox commentStamp: '<historical>' prior: 0!
This class implements a cube with individually colored faces. This example demonstrates how geometric entities that cannot easily be represented by a mesh are implemented by dedicated classes.  !


!B3DIndexedMesh commentStamp: '<historical>' prior: 0!
I represent a generic indexed face mesh. My subclasses define what kind of polygones I use to approximate the surface to be modelled.
 
An indexed mesh approximates the surface of a body in three-dimensional space. It uses a collection of spacial points (the vertices) and a collection of so-called faces.
 
Use of my instance variables:

vertices (mandatory)
instance of B3DVector3Array. Elements are instance of B3DVector3, the spacial points of the mesh. 

faces (mandatory)
instance of B3DIndexedQuadArray for a B3DIndexedQuadMesh, instance of B3DIndexedTriangleArray for a B3DIndexedTriangleMesh The elements are Quads (Triangles). A Quad contains four indices from collection vertices, a triangle contains three indices.

vtxColors (optional)
nil or an instance of B3DColor4Array. That array defines a color (instance of B3DColor4) for every point in vertices. These colors are used for surface coloring.


vtxTexCoords (optional)
nil or an instance of B3DTexture2Array. That array defines a texture coordinate for every point in vertices. The texture itself is not part of the mesh; it is an element of the geometric object.

vtxNormals (optional)
a collection of vertex normals. Vertext normals are needed for surface coloring with lights. Normal vertices are automatically computed when they are needed, but not given. For quadrangle meshes, it is generally better to individually compute vertex normals when they are needed for surface coloring with lights.

faceNormals (optional)
a collection of face normals. Face normals are automatically computed when they are needed, but not given.

bBox (automatically computed)
the bounding box of the modelled solid.



!


!B3DIndexedQuad commentStamp: '<historical>' prior: 0!
I define a quadrangle in space. My four indexed instance variables are integers. These integers are indices of a collection of spacial points. I am the contents class of B3DIndexedQuadArray. !


!B3DIndexedQuadArray commentStamp: '<historical>' prior: 0!
I am used in a B3DIndexedQuadMesh, where I store the faces of the mesh.!


!B3DIndexedTriangle commentStamp: '<historical>' prior: 0!
I define a triangle in space. My three indexed instance variables are integers. These integers are indices of a collection of spacial points.  I am the contents class of B3DIndexedTriangleArray.!


!B3DIndexedTriangleArray commentStamp: '<historical>' prior: 0!
I am used in a B3DIndexedTriangleMesh, where I store the faces of the mesh.!


!B3DMaterialColor commentStamp: '<historical>' prior: 0!
I describe the visual aspect of a surface under colored light.!


!B3DMultiMesh commentStamp: '<historical>' prior: 0!
An instance keeps a collection of meshes.!


!B3DPositionalLight commentStamp: '<historical>' prior: 0!
A light source of this type has a color and a position. Is has no direction, but emits its light into all directions. (Use spot lights when you need both a position and a direction.) A positional light must have an attenuation. The attenuation defines the reduction of the light intensity at increasing distances.

Creation of a positional light:

     light1 := B3DPositionalLight new.
     light1 position: 100 @ 0 @ 0.
     light1 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

!


!B3DScene commentStamp: '<historical>' prior: 0!
The instance keeps all visible and invisible elements of three-dimensional scene. The instance protocol has methods to add scene objects and to render the scene.

Instance variables:
box 
objects 
cameras 
lights 
materials 
defaultCamera 
clearColor!


!B3DSceneObject commentStamp: '<historical>' prior: 0!
I am a named element of a B3DScene. I store a geometric object together with its texture and its material properties.

Instance variables:
name
A string that can be used to identify the geometric object.

matrix
material
A structure that describes the color of the object surface and its properties under different lights. This feature is not always needed; it should be present when you use light sources to color a scene.

texture
A specialized form. Not mandatory. When present, it will be used to render the object surface. Textures are often an attractive way to color a scene when you do not want to use colored lights.

geometry
a structure that defines the surface of the geometric object. That structure is either a kind of a mesh or an instance of a subclass of B3DGeometry. A mesh uses a collection of adjancent triangles (or quadrangles) to approximate a surface. A dedicated subclass of B3DGeometry may implement other techniques to represent a body.

children!


!B3DSimpleMesh commentStamp: '<historical>' prior: 0!
This is a variable class: Its instances may vary in size.
The elements of an instance are required to be instances of B3DSimpleMeshFace, which are polygones.

B3DSimpleMesh is the class of choice to model polyhedra.!


!B3DSimpleMeshFace commentStamp: '<historical>' prior: 0!
This is a variable class: instances may differ in size. An instance of size n  represents a polygon with n vertices. Every vertex is required to be an instance of B3DSimpleMeshVertex.!


!B3DSimpleMeshVertex commentStamp: 'BG 9/4/2002 20:47' prior: 0!
an instance keeps a spacial point, a surface normal at that spacial point, and optionally its color and the texture coordinates. Instances are used in B3DSimpleMeshFace to form polygons.!


!GrafPort commentStamp: '<historical>' prior: 0!
I add additional protocol to BitBlt, the engine that implements bit block transfer operations. I cooperate with an instance of FormCanvas (I am the value of the 'port' instance variable of a FormCanvas).!

