'From Squeak3.2 of 11 July 2002 [latest update: #4952] on 11 September 2002 at 6:05:42 pm'!
"Change Set:		B3DTutorial
Date:			25 August 2002
Author:			Boris Gaertner

This change set contains the sources for my tutorial about Balloon3D. "!

B3DSceneMorph subclass: #AdvancedB3DScenePresenterMorph
	instanceVariableNames: 'rotationAngle stepTime isRotating oldPoint '
	classVariableNames: ''
	poolDictionaries: 'B3DEngineConstants '
	category: 'B3D-Tutorial'!

!AdvancedB3DScenePresenterMorph commentStamp: '<historical>' prior: 0!
This is a slightly simplified copy of AdvancedB3DSceneMorph.
!

Object subclass: #B3DDemoBlockWorld
	instanceVariableNames: 'scene '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial-Demos'!

!B3DDemoBlockWorld commentStamp: '<historical>' prior: 0!
This class shows how a scene can be built from blocks.

To see the examples, execute these statements one by one:

 B3DDemoBlockWorld example1.
 B3DDemoBlockWorld example2.!

Object subclass: #B3DDemoSolids
	instanceVariableNames: 'scene '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial-Demos'!

!B3DDemoSolids commentStamp: '<historical>' prior: 0!
To see the examples, execute the following statements one by one:

  B3DDemoSolids example1.
  B3DDemoSolids example2.
  B3DDemoSolids example3.
  B3DDemoSolids example4.
  B3DDemoSolids example5.
  B3DDemoSolids example6.
  B3DDemoSolids example7.
  B3DDemoSolids example8.

!

Object subclass: #B3DDemoSpheres
	instanceVariableNames: 'scene '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial-Demos'!

!B3DDemoSpheres commentStamp: '<historical>' prior: 0!
This class shows how a sphere can be displayed in different ways. The examples demonstrate the use of textures, material properties and lights.

To see the examples, execute these statements one by one:

 B3DDemoSpheres example1.
 B3DDemoSpheres example2.
 B3DDemoSpheres example3.
 B3DDemoSpheres example4.
 B3DDemoSpheres example5.
 B3DDemoSpheres example6.
 B3DDemoSpheres example7.
 B3DDemoSpheres example8.
 B3DDemoSpheres example9.
 B3DDemoSpheres example10.!

Object subclass: #B3DDemoSurfaces
	instanceVariableNames: 'scene '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial-Demos'!

!B3DDemoSurfaces commentStamp: '<historical>' prior: 0!
This class shows how computed surfaces can be displayed in different ways.

 B3DDemoSurfaces example1.
 B3DDemoSurfaces example2.
 B3DDemoSurfaces example3.
 B3DDemoSurfaces example4.
 B3DDemoSurfaces example5.
 B3DDemoSurfaces example6.
 B3DDemoSurfaces example7.
 B3DDemoSurfaces example8.!

B3DGeometry subclass: #B3DRegularSolid
	instanceVariableNames: 'vertices bBox faces faceNormals vertexNormals vertexColors faceColors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial-Demos'!

!B3DRegularSolid commentStamp: '<historical>' prior: 0!
An instance represents a platonic solid with colored faces. It is entirely possible to represent these solids using instances of B3DSimpleMesh, but it is instructive to see how a geometric object can be defined by a specialized class. 

To create a platonic solid, send the class of the class methods.

Conventions:
vertices is an array of spacial points.
faces is an array that keeps the faces. Every face is represented by an array that contains the indices of its vertices.

faceNormals is an array of vectors, the face normals. 
The following assertion holds: faces size = faceNormals size.

Transformation methods assume that no spacial point and no vector is contained more than once in any of the collections vertices, vertexNormals, faceNormals.!

B3DRegularSolid class
	instanceVariableNames: ''!
BorderedMorph subclass: #B3DTutorialScenePresenterMorph
	instanceVariableNames: 'wheels frameWidth b3DSceneMorph source textAccessor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial'!

!B3DTutorialScenePresenterMorph commentStamp: '<historical>' prior: 0!
This is a slightly modified copy of B3DSceneExplorerMorph.!

Model subclass: #TutorialPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'B3D-Tutorial'!

!TutorialPresenter commentStamp: '<historical>' prior: 0!
This is a class that shows a tutorial.
Execute 
TutorialPresenter openAsMorph
!


!AdvancedB3DScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 09:51'!
rotationAngle
	^rotationAngle! !

!AdvancedB3DScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 09:51'!
rotationAngle: aNumber
	rotationAngle := aNumber! !

!AdvancedB3DScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 09:51'!
scene: aScene
	super scene:  aScene.
	self updateUpVectorForCamera: self scene defaultCamera.
"	self updateHeadlight. "
	self changed! !

!AdvancedB3DScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 09:51'!
stepTime
	^stepTime! !

!AdvancedB3DScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 09:52'!
stepTime: aNumber
	stepTime := aNumber! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 9/1/2002 15:07'!
addDolly: delta
	| camera new |
     scene isNil ifTrue: [^self].
	camera := scene defaultCamera.
	new := camera position - (camera direction * delta).
	camera target = new ifFalse: [
		camera position: new].
	"new := camera direction * delta.
	camera position: camera position - new.
	camera target: camera target - new."
	
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 9/1/2002 15:07'!
addFovAngle: delta
	| camera new |
     scene isNil ifTrue: [^self].
	camera := scene defaultCamera.
	new := camera fov + delta.
	0 < new ifTrue: [
		camera fov: new].
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 8/25/2002 09:53'!
panBy: aPoint
	| camera pt |
	pt := B3DVector3 x: aPoint x y: aPoint y negated z: 0.0.
 	camera := scene defaultCamera.
	pt := pt * (camera direction length) / 200.

	pt := camera asMatrix4x4 inverseTransformation localPointToGlobal: pt.
	pt := pt - camera position.

	camera position: camera position + pt.
	camera target: camera target + pt.
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 8/25/2002 09:53'!
rotateFrom: anOldPoint to: aCurrentPoint
	| camera matrix anOldPointOnSphere aCurrentPointOnSphere center radius |
	center := self bounds center.
	radius := self bounds extent r / 2. 
	anOldPointOnSphere := self pointOnSphereCentered: center radius: radius atPoint: anOldPoint.
	aCurrentPointOnSphere := self pointOnSphereCentered: center radius: radius atPoint: aCurrentPoint.
	camera := scene defaultCamera.
	matrix := B3DMatrix4x4
		rotatedBy: ((anOldPointOnSphere dot: aCurrentPointOnSphere) min: 1.0) arcCos radiansToDegrees
		around:
			(camera asMatrix4x4 inverseTransformation localPointToGlobal:
				(anOldPointOnSphere cross: aCurrentPointOnSphere)) - camera position
		centeredAt: camera target.
	camera position: (matrix localPointToGlobal: camera position).
	camera up: (matrix localPointToGlobal: camera up).
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 9/1/2002 15:07'!
rotateX:  angle
	| camera matrix |
     scene isNil ifTrue: [^self].
	camera := scene defaultCamera.
	matrix := B3DMatrix4x4
		rotatedBy: angle
		around: ((camera position - camera target) cross: camera up)
		centeredAt: camera target.
	camera position: (matrix localPointToGlobal: camera position).
	camera up: (matrix localPointToGlobal: camera up).
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 9/1/2002 15:07'!
rotateY: angle
	| camera matrix |
     scene isNil ifTrue: [^self].
	camera := scene defaultCamera.
	matrix := B3DMatrix4x4
		rotatedBy: angle
		around: camera up
		centeredAt: camera target.
	camera position: (matrix localPointToGlobal: camera position).
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 9/1/2002 15:06'!
rotateZ: angle
	| camera matrix |
    scene isNil ifTrue: [^self].
	camera := scene defaultCamera.
	matrix := B3DMatrix4x4
		rotatedBy: angle
		around: (camera position - camera target)
		centeredAt: camera target.
	camera up: (matrix localPointToGlobal: camera up).
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'camera actions' stamp: 'BG 8/25/2002 09:54'!
transformWithMatrix: matrix
	| camera |
	camera := scene defaultCamera.
	camera position: (matrix localPointToGlobal: camera position).
	camera up: (matrix localPointToGlobal: camera up).
	self changed.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'drawing' stamp: 'BG 9/1/2002 14:39'!
renderOn: aRenderer

    scene isNil ifTrue: [^self].
	aRenderer getVertexBuffer flags: (aRenderer getVertexBuffer flags bitOr: VBTwoSidedLighting).
	super renderOn: aRenderer! !

!AdvancedB3DScenePresenterMorph methodsFor: 'event handling' stamp: 'BG 8/25/2002 09:56'!
handlesMouseDown: evt
	^evt yellowButtonPressed not! !

!AdvancedB3DScenePresenterMorph methodsFor: 'event handling' stamp: 'BG 8/25/2002 09:56'!
mouseDown: evt
	oldPoint := evt cursorPoint.
	super mouseDown: evt.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'event handling' stamp: 'BG 8/25/2002 09:56'!
mouseMove: evt
	oldPoint ifNil: [^super mouseMove: evt].
	(evt redButtonPressed) ifTrue: [
		(evt shiftPressed)
			ifTrue: [self panBy: oldPoint - evt cursorPoint]
			ifFalse: [
				(oldPoint = evt cursorPoint) ifFalse: [
					(self rotateFrom: oldPoint to: evt cursorPoint)]].
		oldPoint := evt cursorPoint].! !

!AdvancedB3DScenePresenterMorph methodsFor: 'initialization' stamp: 'BG 8/25/2002 09:57'!
createDefaultScene! !

!AdvancedB3DScenePresenterMorph methodsFor: 'initialization' stamp: 'BG 8/25/2002 09:58'!
initialize
	super initialize.
	self stepTime: 0.
	self rotationAngle: 1.
     self beStill.
! !

!AdvancedB3DScenePresenterMorph methodsFor: 'properties' stamp: 'BG 8/25/2002 09:58'!
beRotating
	isRotating := true.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'properties' stamp: 'BG 8/25/2002 09:58'!
beStill
	isRotating := false.! !

!AdvancedB3DScenePresenterMorph methodsFor: 'properties' stamp: 'BG 8/25/2002 09:58'!
isRotating
	^isRotating! !

!AdvancedB3DScenePresenterMorph methodsFor: 'properties' stamp: 'BG 8/25/2002 09:59'!
switchRotationStatus
	self isRotating
		ifTrue: [self beStill]
		ifFalse: [self beRotating]! !

!AdvancedB3DScenePresenterMorph methodsFor: 'stepping' stamp: 'BG 9/1/2002 15:07'!
step
    scene isNil ifTrue: [^self].
	self isRotating ifTrue: [
		scene defaultCamera rotateBy: self rotationAngle.
		self changed.].! !

!AdvancedB3DScenePresenterMorph methodsFor: 'private' stamp: 'BG 8/25/2002 09:59'!
pointOnSphereCentered: center radius: radius atPoint: aPoint
	| x y z r s |
	x := (aPoint x - center x) / radius.
	y := (aPoint y - center y) / radius.
	r := (x * x) + (y * y).
	(r > 1.0)
		ifTrue: [
			s := 1.0 / (r sqrt).
			x := s * x negated.
			y := s * y.
			z := 0.0]
		ifFalse: [ z := (1.0 - r) sqrt].
	^B3DVector3 x: x y: y negated z: z! !

!AdvancedB3DScenePresenterMorph methodsFor: 'private' stamp: 'BG 8/25/2002 10:00'!
updateUpVectorForCamera: aCamera
	| oldUp |
	oldUp := aCamera up.
	aCamera up:
		((aCamera direction cross: oldUp) cross: (aCamera direction))! !


!B3DDemoBlockWorld methodsFor: 'common methods' stamp: 'BG 8/25/2002 17:43'!
createStick

    | faces |

   faces := B3DIndexedMesh vrmlCreateBoxFaces.
   ^(B3DSimpleMesh withAll: faces) asIndexedMesh! !

!B3DDemoBlockWorld methodsFor: 'demo1' stamp: 'BG 8/25/2002 17:38'!
createLightsForScene1: aScene

	| ambientLight |

     ambientLight :=B3DAmbientLight new.	
	ambientLight lightColor: (B3DMaterialColor color: Color green).
	
	scene lights add: ambientLight.! !

!B3DDemoBlockWorld methodsFor: 'demo1' stamp: 'BG 8/25/2002 17:54'!
createScene1

	| camera |

	camera _ B3DCamera new.
	camera position: 10@0@10.
	camera target: 2@0@0.
	camera fov: 12.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene1: scene;
          createLightsForScene1: scene.! !

!B3DDemoBlockWorld methodsFor: 'demo1' stamp: 'BG 8/25/2002 17:45'!
createSolidsForScene1: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Stick1'.
	sceneObj geometry: self createStick.
     mat := B3DMaterial new.
	mat ambientPart: (Color gray: 0.99).  " this is suitable for ambient light of all colors. "
							" change the ambient part to see how this property works
							  together with the color of the ambient light. "

	sceneObj material: mat.
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.0  z: 0.0).
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 1.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 2.0  y: -4.0  z: 2.0).

	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Stick2'.
	sceneObj geometry: self createStick.
     mat := B3DMaterial new.
	mat emission: (Color r: 0.8 g: 0.6 b: 0.3);
          shininess: 0.7;
         diffusePart: ("Color gray: 0.25" Color r: 0.6 g: 0.3 b: 0.7).
	mat ambientPart: (Color r:0.4 g: 0.4 b: 0.3).
	sceneObj material: mat.
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.0  z: 0.0).
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 3.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 2.0  y: -4.0  z: 0.0). 

	scene objects add: sceneObj.


	sceneObj _ B3DSceneObject named: 'Stick3'.
	sceneObj geometry: self createStick.
     mat := B3DMaterial new.
	mat emission: (Color r:0.5 g: 0.1 b: 0.2);
          shininess: 0.3;
         diffusePart: ("Color gray: 0.25" Color r: 0.6 g: 0.3 b: 0.7).
	mat ambientPart: (Color r:0.4 g: 0.4 b: 0.3).
	sceneObj material: mat.
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.0  z: 0.0).
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 2.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 2.0  y: -4.0  z: -2.0). 

	scene objects add: sceneObj.
! !

!B3DDemoBlockWorld methodsFor: 'demo1' stamp: 'BG 8/25/2002 17:52'!
descriptionScene1

   ^'This example displays three colored blocks of different height in green ambient light. Note that the edges are not visible in ambient light. The reason is that all surfaces are illuminated with light of the same intensity. '! !

!B3DDemoBlockWorld methodsFor: 'demo1' stamp: 'BG 9/2/2002 12:24'!
show1

    " B3DDemoBlockWorld new show1"

     | view |

  self createScene1.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene1;
     scene: scene.
  view clearColor: (Color gray: 0.7).

  view panBy: (10@10@10);
       addDolly: 1.0;
       rotateY: 10.

  view openInSystemWindow.! !

!B3DDemoBlockWorld methodsFor: 'demo2' stamp: 'BG 8/25/2002 21:01'!
createLightsForScene2: aScene

	| light1 light2 light3 ambientLight |

     ambientLight :=B3DAmbientLight new.	
	ambientLight lightColor: (B3DMaterialColor color: (Color r: 0.2 g: 0.8 b: 0.3)).
	
	scene lights add: ambientLight.
	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoBlockWorld methodsFor: 'demo2' stamp: 'BG 8/25/2002 20:53'!
createScene2

	| camera |

	camera _ B3DCamera new.
	camera position: 10@0@10.
	camera target: 2@0@0.
	camera fov: 12.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene2: scene;
          createLightsForScene2: scene.! !

!B3DDemoBlockWorld methodsFor: 'demo2' stamp: 'BG 8/25/2002 21:02'!
createSolidsForScene2: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Stick1'.
	sceneObj geometry: self createStick.
     mat := B3DMaterial new.
	mat  shininess: 0.8;
          ambientPart: (Color r: 0.3 g: 0.04 b: 0.0);
          specularPart: (Color r: 0.8 g: 0.3 b: 0.1). 

	sceneObj material: mat.
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.0  z: 0.0).
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 1.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 2.0  y: -4.0  z: 2.0).

	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Stick2'.
	sceneObj geometry: self createStick.
     mat := B3DMaterial new.
	mat  shininess: 0.9;
          ambientPart: (Color r: 0.0 g: 0.3 b: 0.04);
          specularPart: (Color r: 0.1 g: 0.8 b: 0.3). 
	sceneObj material: mat.
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.0  z: 0.0).
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 3.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 2.0  y: -4.0  z: 0.0). 

	scene objects add: sceneObj.


	sceneObj _ B3DSceneObject named: 'Stick3'.
	sceneObj geometry: self createStick.
     mat := B3DMaterial new.
	mat  shininess: 0.8;
          ambientPart: (Color r: 0.05 g: 0.0 b: 0.3);
          specularPart: (Color r: 0.3 g: 0.1 b: 0.8). 
	
	sceneObj material: mat.
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.0  z: 0.0).
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 2.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 2.0  y: -4.0  z: -2.0). 

	scene objects add: sceneObj.
! !

!B3DDemoBlockWorld methodsFor: 'demo2' stamp: 'BG 8/25/2002 21:14'!
descriptionScene2

   ^'This example displays three colored blocks of different height in a combination of ambient and directed lights. The faces of the blocks are displayed with colors of different brightness. This is the effect of a combination of directed and ambient lights. The edges are now visible. '! !

!B3DDemoBlockWorld methodsFor: 'demo2' stamp: 'BG 9/2/2002 12:25'!
show2

    " B3DDemoBlockWorld new show2"

     | view |

  self createScene2.
  (view := B3DTutorialScenePresenterMorph new)
    source: self description: #descriptionScene2;
    scene: scene.
  view clearColor: (Color gray: 0.7).

  view panBy: (10@10@10);
       addDolly: 1.0;
       rotateY: 10.

  view openInSystemWindow.! !


!B3DDemoBlockWorld class methodsFor: 'examples' stamp: 'BG 8/25/2002 21:14'!
example1
   " B3DDemoBlockWorld example1"

  B3DDemoBlockWorld new show1! !

!B3DDemoBlockWorld class methodsFor: 'examples' stamp: 'BG 8/25/2002 21:15'!
example2
   " B3DDemoBlockWorld example2"

  B3DDemoBlockWorld new show2! !


!B3DDemoSolids methodsFor: 'common methods' stamp: 'BG 8/29/2002 11:01'!
createBody

  " return a B3DSimpleMesh that represents an dodecahedron
    The solid is point symmetric to the origin of the coordinate system. It is therefore sufficient to compute 10 of its 20 vertrices. The other vertices are obtained by multiplication with -1. "
   | points meshFaces normal vertices normalFor |

   normalFor := [ :v |  | v1 v2 v3 d1 d2 |
		v1 _ v at: 1.
		v2 _ v at: 2.
		v3 _ v at: 3.
		d1 _ v3 - v1.
		d2 _ v2 - v1.
		d1 safelyNormalize.
		d2 safelyNormalize.
		(d1 cross: d2) safelyNormalize.
        ].
   points := Array new: 10.
   1 to: 5 do: 
         [:idx |  
         points at: idx put: (B3DVector3
               x: (Float pi * (idx * 2 + 1) / 5) cos * 2
               y: (Float pi * (idx * 2 + 1) / 5) sin * 2
               z: 1.0 + 5.0 sqrt / 2 + 1.0).
         points at: idx + 5 put: (B3DVector3
               x: (Float pi * (idx * 2 + 1) / 5) cos * (1.0 + 5.0 sqrt)
               y: (Float pi * (idx * 2 + 1) / 5) sin * (1.0 + 5.0 sqrt)
               z: 1.0 + 5.0 sqrt / 2 - 1.0)].
   1 to: 10 do: [:idx | points at: idx put: (points at: idx)
            / (points at: idx) squaredLength sqrt * (0.81573786516665 / 0.79465447229177)].
   meshFaces := OrderedCollection new: 12.

    vertices := points copyFrom: 1  to: 5. 
    normal := normalFor value: vertices.
   
    meshFaces add: (B3DSimpleMeshFace
                           withAll: (vertices collect: [:p | (B3DSimpleMeshVertex new) position: p; normal: normal])).
         vertices := vertices collect: [:p | p negated].
         normal := normalFor value: vertices.

    meshFaces add: (B3DSimpleMeshFace
                       withAll: (vertices collect: [:p | (B3DSimpleMeshVertex new) position: p; normal: normal])). 

  1 to: 5
      do: 
         [ :idx | 
         vertices := Array
                  with: (points at: idx)
                  with: (points at: idx + 5)
                  with: (points at: idx + 2 \\ 5 + 1 + 5) negated
                  with: (points at: idx \\ 5 + 1 + 5)
                  with: (points at: idx \\ 5 + 1).
         normal := normalFor value: vertices.
         meshFaces add: (B3DSimpleMeshFace
                               withAll: (vertices collect: [:p | (B3DSimpleMeshVertex new)
                                                                         position: p; 
                                                                         normal: normal])).
         vertices := vertices collect: [:p | p negated].
         normal := normalFor value: vertices.
         meshFaces add: (B3DSimpleMeshFace
                              withAll: (vertices collect: [:p | B3DSimpleMeshVertex new
                                                               position: p;
                                                               normal: normal])).
         ].

  ^B3DSimpleMesh withAll: meshFaces
 
 
! !

!B3DDemoSolids methodsFor: 'common methods' stamp: 'BG 8/28/2002 21:04'!
createBodyWithFaceColors: colors

  " return a B3DSimpleMesh that represents an dodecahedron
    The solid is point symmetric to the origin of the coordinate system. It is therefore sufficient tocompute 10 of its 20 vertrices. The other vertices are obtained by multiplication with -1. "
   | points meshFaces normal vertices normalFor |

   normalFor := [ :v |  | v1 v2 v3 d1 d2 |
		v1 _ v at: 1.
		v2 _ v at: 2.
		v3 _ v at: 3.
		d1 _ v3 - v1.
		d2 _ v2 - v1.
		d1 safelyNormalize.
		d2 safelyNormalize.
		(d1 cross: d2) safelyNormalize.
        ].
   points := Array new: 10.
   1 to: 5 do: 
         [:idx |  
         points at: idx put: (B3DVector3
               x: (Float pi * (idx * 2 + 1) / 5) cos * 2
               y: (Float pi * (idx * 2 + 1) / 5) sin * 2
               z: 1.0 + 5.0 sqrt / 2 + 1.0).
         points at: idx + 5 put: (B3DVector3
               x: (Float pi * (idx * 2 + 1) / 5) cos * (1.0 + 5.0 sqrt)
               y: (Float pi * (idx * 2 + 1) / 5) sin * (1.0 + 5.0 sqrt)
               z: 1.0 + 5.0 sqrt / 2 - 1.0)].
   1 to: 10 do: [:idx | points at: idx put: (points at: idx)
            / (points at: idx) squaredLength sqrt * (0.81573786516665 / 0.79465447229177)].
   meshFaces := OrderedCollection new: 12.

    vertices := points copyFrom: 1  to: 5. 
    normal := normalFor value: vertices.
   
    meshFaces add: (B3DSimpleMeshFace
                           withAll: (vertices collect: [:p | (B3DSimpleMeshVertex new) position: p;                                                                    normal: normal;
                                                            color: colors first])).
    vertices := vertices collect: [:p | p negated].
    normal := normalFor value: vertices.

    meshFaces add: (B3DSimpleMeshFace
                       withAll: (vertices collect: [:p | (B3DSimpleMeshVertex new) position: p; normal: normal; color: colors first])). 

  1 to: 5
      do: 
         [ :idx | 
         vertices := Array
                  with: (points at: idx)
                  with: (points at: idx + 5)
                  with: (points at: idx + 2 \\ 5 + 1 + 5) negated
                  with: (points at: idx \\ 5 + 1 + 5)
                  with: (points at: idx \\ 5 + 1).
         normal := normalFor value: vertices.
         meshFaces add: (B3DSimpleMeshFace
                               withAll: (vertices collect: [:p | (B3DSimpleMeshVertex new)
                                                                         position: p; 
                                                                         normal: normal; color: (colors at: idx + 1)])).
         vertices := vertices collect: [:p | p negated].
         normal := normalFor value: vertices.
         meshFaces add: (B3DSimpleMeshFace
                              withAll: (vertices collect: [:p | B3DSimpleMeshVertex new
                                                               position: p;
                                                               normal: normal; color: (colors at: idx + 1)])).
         ].

  ^B3DSimpleMesh withAll: meshFaces
 
 
! !

!B3DDemoSolids methodsFor: 'demo1' stamp: 'BG 8/28/2002 18:24'!
createLightsForScene1: aScene

	| light1 light2 light3 |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoSolids methodsFor: 'demo1' stamp: 'BG 8/28/2002 08:56'!
createScene1

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene1: scene;
          createLightsForScene1: scene.! !

!B3DDemoSolids methodsFor: 'demo1' stamp: 'BG 8/28/2002 20:48'!
createSolidsForScene1: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: self createBody.
     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.

	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo1' stamp: 'BG 8/29/2002 09:20'!
descriptionScene1

  ^'A dodecahedron with a reflecting white surface in the light of three colored directed lights. The pentangles are represented by instances of B3DSimpleMeshFace. An instance of B3DSimpleMesh is used to put the faces together to form a solid.'! !

!B3DDemoSolids methodsFor: 'demo1' stamp: 'BG 9/2/2002 12:05'!
show1

    " B3DDemoSolids new show1"

     | view |

  self createScene1.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene1;
     scene: scene.

  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo2' stamp: 'BG 8/28/2002 20:42'!
createLightsForScene2: aScene


	| light1 light2 light3 |

	light1 := B3DPositionalLight new.
     light1 position: 100 @ 0 @ 0.
     light1 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DPositionalLight new.
     light2 position: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DPositionalLight new.
     light3 position: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoSolids methodsFor: 'demo2' stamp: 'BG 8/28/2002 20:47'!
createScene2

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene1: scene;
          createLightsForScene2: scene.! !

!B3DDemoSolids methodsFor: 'demo2' stamp: 'BG 8/28/2002 20:50'!
descriptionScene2


  ^'a dodecahedron with a reflecting white surface in the light of three colored positional lights. This solid is modelled with a B3DSimpleMesh.  '! !

!B3DDemoSolids methodsFor: 'demo2' stamp: 'BG 9/2/2002 12:10'!
show2

    " B3DDemoSolids new show2"

     | view |

  self createScene2.
  (view := B3DTutorialScenePresenterMorph new)
      source: self description: #descriptionScene2;
    scene: scene.

  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo3' stamp: 'BG 8/28/2002 22:08'!
createLightsForScene3: aScene
! !

!B3DDemoSolids methodsFor: 'demo3' stamp: 'BG 8/28/2002 20:48'!
createScene3

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene3: scene;
          createLightsForScene3: scene.! !

!B3DDemoSolids methodsFor: 'demo3' stamp: 'BG 8/29/2002 12:09'!
createSolidsForScene3: aScene

	| sceneObj |

	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: (self createBodyWithFaceColors: 
           (Array with: (Color yellow asB3DColor)
                    with: (Color lightGreen asB3DColor)
                    with: (Color blue asB3DColor)
                    with: (Color orange asB3DColor)
                    with: (Color cyan asB3DColor)
                    with: (Color brown asB3DColor))).

	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo3' stamp: 'BG 8/29/2002 12:42'!
descriptionScene3

  ^'A dodecahedron with colored faces. The colors of the points (instances of B3DSimpleMeshVertex) determine the color of a face. Here all five vertices of a face have the same color.  Pointsymmetric faces have the same colors.

 No lights, no texture and no materials are needed to show that solid with colored faces.

Note that this requires a minor change in B3DSimpleMeshFace>>renderOn:'! !

!B3DDemoSolids methodsFor: 'demo3' stamp: 'BG 9/2/2002 12:11'!
show3

    " B3DDemoSolids new show3"

     | view |

  self createScene3.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene3;
     scene: scene.
 
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo4' stamp: 'BG 8/29/2002 12:44'!
createScene4

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene4: scene;
          createLightsForScene3: scene.! !

!B3DDemoSolids methodsFor: 'demo4' stamp: 'BG 9/2/2002 14:24'!
createSolidsForScene4: aScene

	| sceneObj |

	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: (self createBodyWithFaceColors: 
           (Array with: (Color yellow asB3DColor)
                    with: (Color lightGreen asB3DColor)
                    with: (Color blue asB3DColor)
                    with: (Color orange asB3DColor)
                    with: (Color cyan asB3DColor)
                    with: (Color brown asB3DColor))).
     sceneObj geometry: (sceneObj geometry transformedBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5))). 
     sceneObj geometry translateBy: (B3DVector3 x: 1.0  y: 0.5  z: 1.0).
	aScene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Surface2'.
	sceneObj geometry: (self createBodyWithFaceColors: 
           (Array with: (Color yellow asB3DColor)
                    with: (Color lightGreen asB3DColor)
                    with: (Color blue asB3DColor)
                    with: (Color orange asB3DColor)
                    with: (Color cyan asB3DColor)
                    with: (Color brown asB3DColor))).
     sceneObj geometry: (sceneObj geometry transformedBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5))).     
	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo4' stamp: 'BG 8/29/2002 15:18'!
descriptionScene4

  ^'Two dodecahedra with colored faces.

 No lights, no texture and no materials are needed to show that solid with colored faces.

The scene was build with geometric transformations. Note that B3DSimpleMesh does not implement in place transformation: The method #transformBy:  returns a new instance.'! !

!B3DDemoSolids methodsFor: 'demo4' stamp: 'BG 9/2/2002 12:11'!
show4

    " B3DDemoSolids new show4"

     | view |

  self createScene4.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene4;
     scene: scene.
 
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo5' stamp: 'BG 8/29/2002 12:08'!
createLightsForScene5: aScene! !

!B3DDemoSolids methodsFor: 'demo5' stamp: 'BG 8/29/2002 12:08'!
createScene5

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene5: scene;
          createLightsForScene5: scene.! !

!B3DDemoSolids methodsFor: 'demo5' stamp: 'BG 9/8/2002 14:22'!
createSolidsForScene5: aScene

	| sceneObj solid |

	sceneObj _ B3DSceneObject named: 'Surface1'.
     solid := B3DRegularSolid dodekahedron.
 
    solid setFaceColors:
        (Array with: (Color yellow asB3DColor)
                    with: (Color yellow asB3DColor)
                    with: (Color orange asB3DColor)
                    with: (Color orange asB3DColor)
                    with: (Color cyan asB3DColor)
                    with: (Color cyan asB3DColor)),
(Array with: (Color lightGreen asB3DColor)
                    with: (Color lightGreen asB3DColor)
                    with: (Color blue asB3DColor)
                    with: (Color blue asB3DColor)
                    with: (Color brown asB3DColor)
                    with: (Color brown asB3DColor)) .
   "
     solid setVertexColors:  "
	sceneObj geometry: solid.
 
	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo5' stamp: 'BG 9/2/2002 12:20'!
descriptionScene5

  ^'A dodecahedron with colored faces. An instance of the specialized geometric object B3DRegularSolid is used to represent and to render that solid.

 No lights, no texture and no materials are needed to show that solid with colored faces.'! !

!B3DDemoSolids methodsFor: 'demo5' stamp: 'BG 9/2/2002 12:17'!
show5

    " B3DDemoSolids new show5"

     | view |

  self createScene5.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene5;
     scene: scene.
 
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo6' stamp: 'BG 9/2/2002 14:37'!
createLightsForScene6: aScene! !

!B3DDemoSolids methodsFor: 'demo6' stamp: 'BG 9/2/2002 14:36'!
createScene6

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene6: scene;
          createLightsForScene6: scene.! !

!B3DDemoSolids methodsFor: 'demo6' stamp: 'BG 9/8/2002 14:23'!
createSolidsForScene6: aScene

	| sceneObj solid colors c |

	sceneObj _ B3DSceneObject named: 'Surface1'.
     solid := B3DRegularSolid dodekahedron.
 
    c := OrderedCollection new: 5.
    c add: (Color r: 0.6 g: 0.0 b: 0.0);
            add: (Color r: 0.0 g: 0.6 b: 0.0);
            add: (Color r: 0.0 g: 0.0 b: 0.6);
            add: (Color r: 0.6 g: 0.6 b: 0.0);
            add: (Color r: 0.0 g: 0.6 b: 0.6).
     colors := OrderedCollection new: 12. 
     12 timesRepeat: [colors add: c].

     solid setVertexColors:  colors.
	sceneObj geometry: solid.
 
	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo6' stamp: 'BG 9/2/2002 15:49'!
descriptionScene6

  ^'A dodecahedron with colored vertices. An instance of the specialized geometric object B3DRegularSolid is used to represent and to render that solid.
All 12 faces of the solid are colored with the same vertex coloring. The face coloring is computed from the vertex colors by interpolation. 
No lights, no texture and no materials are needed to show that solid with colored faces.'! !

!B3DDemoSolids methodsFor: 'demo6' stamp: 'BG 9/2/2002 14:36'!
show6

    " B3DDemoSolids new show6"

     | view |

  self createScene6.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene6;
     scene: scene.
 
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo7' stamp: 'BG 9/2/2002 19:46'!
createScene7

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene7: scene;
          createLightsForScene6: scene.! !

!B3DDemoSolids methodsFor: 'demo7' stamp: 'BG 9/8/2002 14:23'!
createSolidsForScene7: aScene

	| sceneObj solid colors c |

	sceneObj _ B3DSceneObject named: 'Surface1'.
     solid := B3DRegularSolid dodekahedron.

     colors := OrderedCollection new: 12.
     1 to: 12 do:
       [:hue | c := OrderedCollection new: 5.
           1 to: 5 do:
              [:s | 
                  c add: (Color h: hue*30 + (s * 5)  s: s  / 10.0 v: 0.9).
                " c add: (Color h: hue*30 + (s * 5)  s: s + s  / 10.0 v: 0.9) " 
                " c add: (Color h: hue*30 + (s * 5)  s: s + s  / 10.0 v: 0.9 - (s/10)) "
              ].
           colors add: c.
      ].

     solid setVertexColors:  colors.
	sceneObj geometry: solid.
 
	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo7' stamp: 'BG 9/2/2002 19:53'!
descriptionScene7

  ^'A dodecahedron with colored vertices. An instance of the specialized geometric object B3DRegularSolid is used to represent and to render that solid.
All 12 faces of the solid are colored with the same vertex coloring. The face coloring is computed from the vertex colors by interpolation. All vertex colors of a face have the same hue and brightness, but different saturations. This special coloring demonstrates that it is sometimes better to use the hue-sturation-brightness color model. (The r-g-b model is often used because it reflects a basic property of a color screen. The problem with that model is that you cannot forecast the resulting color from a given combination of r-g-b values.)
 
No lights, no texture and no materials are needed to show that solid with colored faces.'! !

!B3DDemoSolids methodsFor: 'demo7' stamp: 'BG 9/2/2002 19:51'!
show7

    " B3DDemoSolids new show7"

     | view |

  self createScene7.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene7;
     scene: scene.
  view clearColor: (Color gray: 0.8).
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSolids methodsFor: 'demo8' stamp: 'BG 9/6/2002 12:24'!
createScene8

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-8.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene8: scene;
          createLightsForScene6: scene.! !

!B3DDemoSolids methodsFor: 'demo8' stamp: 'BG 9/6/2002 12:25'!
createSolidsForScene8: aScene

	| sceneObj solid colors c |

	sceneObj _ B3DSceneObject named: 'Surface1'.
     solid := B3DRegularSolid icosahedron.

     colors := OrderedCollection new: 20.
     1 to: 20 do:
       [:hue | c := OrderedCollection new: 3.
           1 to: 3 do:
              [:s | 
                  c add: (Color h: hue*18 + (s * 3)  s: s + s  / 10.0 v: 0.9).
                " c add: (Color h: hue*18 + (s * 3)  s: s + s  / 10.0 v: 0.9) " 
                " c add: (Color h: hue*18 + (s * 3)  s: s + s  / 10.0 v: 0.9 - (s/10)) "
              ].
           colors add: c asArray.
      ].

     solid setVertexColors:  colors asArray.
	sceneObj geometry: solid.
 
	aScene objects add: sceneObj.
! !

!B3DDemoSolids methodsFor: 'demo8' stamp: 'BG 9/6/2002 12:23'!
descriptionScene8

  ^'A icosahedron with colored vertices. An instance of the specialized geometric object B3DRegularSolid is used to represent and to render that solid.
All 12 faces of the solid are colored with the same vertex coloring. The face coloring is computed from the vertex colors by interpolation. All vertex colors of a face have the same hue and brightness, but different saturations. This special coloring demonstrates that it is sometimes better to use the hue-sturation-brightness color model. (The r-g-b model is often used because it reflects a basic property of a color screen. The problem with that model is that you cannot forecast the resulting color from a given combination of r-g-b values.)
 
No lights, no texture and no materials are needed to show that solid with colored faces.'! !

!B3DDemoSolids methodsFor: 'demo8' stamp: 'BG 9/6/2002 12:08'!
show8

    " B3DDemoSolids new show8"

     | view |

  self createScene8.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene8;
     scene: scene.
  view clearColor: (Color gray: 0.8).
  view rotateX: 25.4.
  view openInSystemWindow.! !


!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 8/29/2002 09:14'!
example1
   " B3DDemoSolids example1"

    B3DDemoSolids new show1! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 8/29/2002 09:14'!
example2
   " B3DDemoSolids example2"

    B3DDemoSolids new show2! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 8/29/2002 09:14'!
example3
   " B3DDemoSolids example3"

    B3DDemoSolids new show3! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 8/29/2002 13:52'!
example4
   " B3DDemoSolids example4"

    B3DDemoSolids new show4! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 8/29/2002 13:52'!
example5
   " B3DDemoSolids example5"

    B3DDemoSolids new show5! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 9/2/2002 17:15'!
example6
   " B3DDemoSolids example6"

    B3DDemoSolids new show6! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 9/2/2002 19:54'!
example7
   " B3DDemoSolids example7"

    B3DDemoSolids new show7! !

!B3DDemoSolids class methodsFor: 'examples' stamp: 'BG 9/7/2002 12:04'!
example8
   " B3DDemoSolids example8"

    B3DDemoSolids new show8! !


!B3DDemoSpheres methodsFor: 'common methods' stamp: 'BG 8/25/2002 12:30'!
colorTilesWith: firstColor and: lastColor 

  | form txt nroPu ps pt |

  nroPu := 12.

  form := Form extent: (nroPu@ nroPu*16) depth: 32.
   ps := 0 .
   0 to: nroPu//2 do:
   [:j |
   pt := 0 @ ps.
   0 to: nroPu//2 do:
    [:idx |
      form fill: (0 @ 0 + pt extent: 16@16) fillColor: firstColor;
            fill: (16 @16 + pt extent: 16 @ 16) fillColor: firstColor;
            fill: (0 @ 16 + pt extent: 16 @ 16) fillColor: lastColor;
            fill: (16 @ 0 + pt extent: 16 @ 16) fillColor: lastColor.
      pt := (32 @ 0) + pt
     ].
    ps := 32 + ps
   ].
  txt := form asTexture.
  txt wrap: true.
  txt interpolate: false.
  txt envMode: 0.
  ^txt! !

!B3DDemoSpheres methodsFor: 'common methods' stamp: 'BG 8/25/2002 17:00'!
gradientTexture
    | txt fill bc |

	fill _ GradientFillStyle ramp: {
		0.0 -> (Color r: 0.05 g: 0.5 b: 1.0). 
		0.5 -> (Color r: 0.70 g: 0.85 b: 1.0). 
		1.0 -> (Color r: 0.05 g: 0.5 b: 1.0)}.
	fill origin: (50@0).
    
	fill direction: 100@0.
	fill radial: false.
    bc := BalloonCanvas extent: (200 @200) depth: 32.
    bc fillRectangle: (0@0 extent: 200 @ 200)
         fillStyle: fill.

  txt := bc form asTexture.
  txt wrap: true.
  txt interpolate: false.
  txt envMode: 1.
  ^txt! !

!B3DDemoSpheres methodsFor: 'common methods' stamp: 'BG 9/2/2002 18:33'!
gradientTextureForSphere
    | txt fill bc |

    fill _ GradientFillStyle ramp: {
        0.0 -> (Color r: 0.85 g: 0.85 b: 0.75).
        1.0 -> (Color r: 0.85 g: 0.5 b: 0.05)}.
    fill origin: (200@200).
    
    fill direction: 140@140.
    fill radial: true.
    bc := BalloonCanvas extent: (400 @ 400) depth: 32.
    bc fillRectangle: (0@0 extent: 400 @ 400)
        fillStyle: fill.

  txt := bc form asTexture.
  txt wrap: true.
  txt interpolate: false.
  txt envMode: 1.
  ^txt! !

!B3DDemoSpheres methodsFor: 'common methods' stamp: 'BG 9/2/2002 18:38'!
gradientTextureForSphere2
    | txt fill bc |

    fill _ GradientFillStyle ramp: {
        0.0 -> (Color r: 0.85 g: 0.85 b: 0.75).
        1.0 -> (Color r: 0.5 g: 0.85 b: 0.05)}.
    fill origin: (200@200).
    
    fill direction: 140@140.
    fill radial: true.
    bc := BalloonCanvas extent: (400 @ 400) depth: 32.
    bc fillRectangle: (0@0 extent: 400 @ 400)
        fillStyle: fill.

  txt := bc form asTexture.
  txt wrap: true.
  txt interpolate: false.
  txt envMode: 1.
  ^txt! !

!B3DDemoSpheres methodsFor: 'demo1' stamp: 'BG 8/25/2002 13:00'!
createScene1
  
	| sceneObj camera mat |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.
     mat := B3DMaterial new.
	mat emission: Color yellow.  "remove this line tto get a black sphere. "
	sceneObj material: mat.

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo1' stamp: 'BG 8/27/2002 05:01'!
descriptionScene1

  ^'A single sphere with a yellow surface is shown.

B3DIndexedMesh vrmlCreateSphereFaces is used to create the geometric object.

No lights are used. The sphere emits yellow light. When you remove the statement ''mat emission: Color yellow. '', the sphere appears in black.

Try all five wheels of the display morph. You will find, that you can rotate and zoom the scene. The window menu can be used to toggle scene ratation.'! !

!B3DDemoSpheres methodsFor: 'demo1' stamp: 'BG 9/2/2002 11:51'!
show1

    " B3DDemoSpheres new show1"

     | view |

  self createScene1.
  (view := B3DTutorialScenePresenterMorph new)
      source: self description: #descriptionScene1;
    scene: scene.

  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo2' stamp: 'BG 8/25/2002 12:49'!
createScene2

	| sceneObj camera mat |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.
     sceneObj texture: (self colorTilesWith: (Color r: 0.0 g: 0.8 b: 0.0)
                                and: (Color r: 0.0 g: 0.55 b: 0.0)). 
     mat := B3DMaterial new.
	mat emission: Color yellow.  "  a red light would show a black sphere "
	sceneObj material: mat.

	scene objects add: sceneObj.
! !

!B3DDemoSpheres methodsFor: 'demo2' stamp: 'BG 8/25/2002 14:48'!
descriptionScene2

  ^'A single sphere with texture is shown. No lights are used. The texture is used to color the surface with a chess board pattern.

The sphere emits yellow light, The green texture can be seen in yellow light. When you change the light emission of the sphere to red, the sphere will be drawn black (because red and green have no colors in common. Yellow and green have.) It is of couse also possible to see the texture when the light emission of the sphere is set to white (or to light gray) 

Try again all five wheels of the display morph. You will find, that the texture adds a spacial impression that you missed in the first example.'! !

!B3DDemoSpheres methodsFor: 'demo2' stamp: 'BG 9/2/2002 11:53'!
show2

    " B3DDemoSpheres new show2"

     | view |

 self createScene2.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene2;
     scene: scene.

  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo3' stamp: 'BG 8/25/2002 12:55'!
createLightsForScene3: aScene

	| ambientLight |

     ambientLight :=B3DAmbientLight new.	
	ambientLight lightColor: (B3DMaterialColor color: Color green).
	
	scene lights add: ambientLight.
! !

!B3DDemoSpheres methodsFor: 'demo3' stamp: 'BG 8/25/2002 12:34'!
createScene3

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene3: scene;
          createLightsForScene3: scene.
! !

!B3DDemoSpheres methodsFor: 'demo3' stamp: 'BG 8/25/2002 13:17'!
createSolidsForScene3: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.
     sceneObj texture: (self colorTilesWith: (Color r: 0.0 g: 0.8 b: 0.0)
                                and: (Color r: 0.0 g: 0.55 b: 0.0)). 
     mat := B3DMaterial new.
	mat ambientPart: (Color gray: 0.99).  " this is suitable for ambient light of all colors. "
							" change the ambient part to see how this property works
							  together with the color of the ambient light. "

	sceneObj material: mat.

	scene objects add: sceneObj.
! !

!B3DDemoSpheres methodsFor: 'demo3' stamp: 'BG 8/25/2002 14:25'!
descriptionScene3

  ^'A single sphere with texture is shown in ambient green light. The green texture is used to color the surface with a chess board pattern.
To see the texture, the material of the surface must have an ambient part that contains green. (Suitable colors are white, gray, yellow, but not red or blue.)

For a better understanding of how light color and material properties work together, you should change the color of the ambient light and the ambient part of the surface material. You will find that the surface is rendered in the common color of the ambient light and the ambient part of the material. A black surface means that there is no common color.'! !

!B3DDemoSpheres methodsFor: 'demo3' stamp: 'BG 9/2/2002 11:54'!
show3

    " B3DDemoSpheres new show3"

     | view |

  self createScene3.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene3;
     scene: scene.

  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo4' stamp: 'BG 8/25/2002 13:42'!
createLightsForScene4: aScene

	| light1 light2 light3 |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.

! !

!B3DDemoSpheres methodsFor: 'demo4' stamp: 'BG 8/25/2002 13:18'!
createScene4

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene4: scene;
          createLightsForScene4: scene.! !

!B3DDemoSpheres methodsFor: 'demo4' stamp: 'BG 8/25/2002 13:41'!
createSolidsForScene4: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo4' stamp: 'BG 9/2/2002 19:36'!
descriptionScene4

  ^'A single white sphere is shown in the light of three directed lights of different color.

Proposals for further work:
You should now be able to add (in method createLightsForScene4:) an ambient white light. When you do only that, you will notice no difference in the scene. To see a difference, you will have to add an additional ambient part to the material of the sphere. This has to be be done in method createSolidsForScene4:. Add this statement:

mat ambientPart: (Color gray: 0.2)

It is instructive to vary the argument of message ''gray:'' and to observe the effect. Try to forecast what you will see. (B3DDemoSpheres>>demo4a shows that exercise.)'! !

!B3DDemoSpheres methodsFor: 'demo4' stamp: 'BG 9/2/2002 10:17'!
show4

    " B3DDemoSpheres new show4"

     | view |

  self createScene4.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene4;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo4a' stamp: 'BG 9/2/2002 09:44'!
createLightsForScene4a: aScene

	| light1 light2 light3 ambientLight |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.
     ambientLight :=B3DAmbientLight new.	
	ambientLight lightColor: (B3DMaterialColor color: Color white).
	
	scene lights add: ambientLight.


! !

!B3DDemoSpheres methodsFor: 'demo4a' stamp: 'BG 9/2/2002 09:44'!
createScene4a

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene4a: scene;
          createLightsForScene4a: scene.! !

!B3DDemoSpheres methodsFor: 'demo4a' stamp: 'BG 9/2/2002 09:44'!
createSolidsForScene4a: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          ambientPart: (Color gray: 0.1);
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo4a' stamp: 'BG 9/2/2002 09:46'!
descriptionScene4a

  ^'A single white sphere is shown in the light of three directed lights of different color. Additionally a white ambient light is used. Response to ambient light was added to the material properties of the sphere.'! !

!B3DDemoSpheres methodsFor: 'demo4a' stamp: 'BG 9/2/2002 10:22'!
show4a

    " B3DDemoSpheres new show4a"

     | view |

  self createScene4a.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene4a;
     scene: scene.
 view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo5' stamp: 'BG 8/25/2002 13:43'!
createLightsForScene5: aScene

	| light1 light2 light3 |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoSpheres methodsFor: 'demo5' stamp: 'BG 8/25/2002 13:43'!
createScene5

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene5: scene;
          createLightsForScene5: scene.! !

!B3DDemoSpheres methodsFor: 'demo5' stamp: 'BG 8/25/2002 13:44'!
createSolidsForScene5: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.
     sceneObj texture: (self colorTilesWith: (Color r: 0.8 g: 0.8 b: 0.8)
                                and: (Color r: 0.9 g: 0.9 b: 0.9)). 

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo5' stamp: 'BG 8/25/2002 14:23'!
descriptionScene5

  ^'A single white sphere with texture is shown in the light of three directed lights of different color. The material properties shininess and specular part define what colors of directed light are reflected.'! !

!B3DDemoSpheres methodsFor: 'demo5' stamp: 'BG 9/2/2002 11:56'!
show5

    " B3DDemoSpheres new show5"

     | view |

  self createScene5.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene5;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo6' stamp: 'BG 8/25/2002 14:05'!
createLightsForScene6: aScene

	| light1 light2 light3 |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoSpheres methodsFor: 'demo6' stamp: 'BG 8/30/2002 22:37'!
createScene6

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene6: scene;
          createLightsForScene6: scene.! !

!B3DDemoSpheres methodsFor: 'demo6' stamp: 'BG 8/25/2002 14:07'!
createSolidsForScene6: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.7 y: 0.7 z: 0.7)).
	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Sphere2'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 1.0  y: 0.5  z: 1.0).

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo6' stamp: 'BG 8/25/2002 14:23'!
descriptionScene6

  ^'Two white spheres without texture are shown in the light of three directed lights of different color. This example shows the use of scaling and translation to create a scene.'! !

!B3DDemoSpheres methodsFor: 'demo6' stamp: 'BG 9/2/2002 11:57'!
show6

    " B3DDemoSpheres new show6"

     | view |
  self createScene6.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene6;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view beRotating; openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo6a' stamp: 'BG 8/30/2002 22:40'!
createLightsForScene6a: aScene

	| light1 light2 light3 ambientLight |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.

     ambientLight := B3DAmbientLight new.
	ambientLight lightColor: (B3DMaterialColor color: Color white).
	
	aScene lights add: ambientLight.
! !

!B3DDemoSpheres methodsFor: 'demo6a' stamp: 'BG 8/30/2002 22:37'!
createScene6a

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene6a: scene;
          createLightsForScene6a: scene.! !

!B3DDemoSpheres methodsFor: 'demo6a' stamp: 'BG 8/30/2002 22:44'!
createSolidsForScene6a: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          ambientPart: (Color gray: 0.1); 
          specularPart: (Color gray: 0.9). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.7 y: 0.7 z: 0.7)).
	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Sphere2'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.7;
          ambientPart: (Color gray: 0.1);
          specularPart: (Color gray: 0.9). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 1.0  y: 0.5  z: 1.0).

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo6a' stamp: 'BG 9/2/2002 12:00'!
descriptionScene6a

  ^'Two white spheres without texture are shown in the light of three directed lights of different color.  Additionally a white ambient light is used. Response to ambient light was added to the material properties of the spheres.
This example shows the use of scaling and translation to create a scene.'! !

!B3DDemoSpheres methodsFor: 'demo6a' stamp: 'BG 9/2/2002 11:59'!
show6a

    " B3DDemoSpheres new show6a"

     | view |

  self createScene6a.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene6a;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view beRotating; openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo7' stamp: 'BG 8/25/2002 15:36'!
createLightsForScene7: aScene

	| light1 light2 light3 |

	light1 := B3DPositionalLight new.
     light1 position: 100 @ 0 @ 0.
     light1 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DPositionalLight new.
     light2 position: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DPositionalLight new.
     light3 position: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoSpheres methodsFor: 'demo7' stamp: 'BG 8/25/2002 15:29'!
createScene7

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene7: scene;
          createLightsForScene7: scene.! !

!B3DDemoSpheres methodsFor: 'demo7' stamp: 'BG 8/25/2002 15:40'!
createSolidsForScene7: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.6;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.7 y: 0.7 z: 0.7)).
	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Sphere2'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 1.0  y: 0.5  z: 1.0).

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo7' stamp: 'BG 8/25/2002 15:45'!
descriptionScene7

  ^'Two white spheres without texture are shown in the light of three positional lights of different color. This example shows the use of scaling and translation to create a scene.

Positional lights do not have a direction: they emit their light in all directions. Use spotlights when you need both a position and a direction. Positional lights must have an attenuation which defines the reduction of light intensity at increasing distances. It is possible to define an attenuation that has only a constant part. 

Note that the smaller sphere is less reflective than the larger one. The difference is in the shininess attribute of the materials.'! !

!B3DDemoSpheres methodsFor: 'demo7' stamp: 'BG 9/2/2002 12:02'!
show7

    " B3DDemoSpheres new show7"

     | view |
  self createScene7.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene7;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view beRotating; openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo8' stamp: 'BG 8/25/2002 16:39'!
createLightsForScene8: aScene

	| light1 light2 light3 |

	light1 := B3DSpotLight new.
     light1 position: 20 @ 0 @ 0;
             direction: 20 negated @ 0 @ 0;
             target: 0 @ 0 @ 0.
     light1 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.2).
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
     light1 minAngle: 3;
             maxAngle: 5.
	scene lights add: light1.

	light2 := B3DSpotLight new.
     light2 position: (120 degreesToRadians cos) * 20  @ (120 degreesToRadians sin * 20) @ 0;
             direction: (120 degreesToRadians cos) * 20 negated  @ (120 degreesToRadians sin * 20 negated) @ 0;
             target: 0 @ 0 @ 0.
     light2 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
     light2 minAngle: 3;
             maxAngle: 5.
	scene lights add: light2.

	light3 := B3DSpotLight new.
     light3 position: (240 degreesToRadians cos) * 20  @ (240 degreesToRadians sin * 20) @ 0;
             direction: (240 degreesToRadians cos) * 20 negated @ (240 degreesToRadians sin * 20 negated) @ 0;
             target: 0 @ 0 @ 0.
     light3 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
     light3 minAngle: 5;
             maxAngle: 7.
	scene lights add: light3.! !

!B3DDemoSpheres methodsFor: 'demo8' stamp: 'BG 8/25/2002 16:16'!
createScene8

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-6.
	camera target: 0@0@0.
	camera fov: 15.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene8: scene;
          createLightsForScene8: scene.! !

!B3DDemoSpheres methodsFor: 'demo8' stamp: 'BG 8/25/2002 16:41'!
createSolidsForScene8: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.6;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.7 y: 0.7 z: 0.7)).
	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Sphere2'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 1.0  y: 0.5  z: 1.0).

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo8' stamp: 'BG 8/25/2002 16:24'!
descriptionScene8

  ^'Two white spheres without texture are shown in the light of three spotlights of different color. This example shows the use of scaling and translation to create a scene.

A spotlight has a direction and a radiation angle. Spotlights must have an attenuation which defines the reduction of light intensity at increasing distances. It is possible to define an attenuation that has only a constant part. 

Note that the smaller sphere is less reflective than the larger one. The difference is in the shininess attribute of the materials.'! !

!B3DDemoSpheres methodsFor: 'demo8' stamp: 'BG 9/2/2002 12:03'!
show8

    " B3DDemoSpheres new show8"

     | view |

  self createScene8.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene8;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view beRotating; openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo9' stamp: 'BG 8/25/2002 16:58'!
createLightsForScene9: aScene

	| light1 light2 light3 |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (120 degreesToRadians cos) * 100  @ (120 degreesToRadians sin * 100) @ 0.
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (240 degreesToRadians cos) * 100  @ (240 degreesToRadians sin * 100) @ 0.
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
	scene lights add: light3.! !

!B3DDemoSpheres methodsFor: 'demo9' stamp: 'BG 8/26/2002 21:56'!
createScene9

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@25.
	camera target: 0@0@0.
	camera fov: 9.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene9: scene;
          createLightsForScene9: scene.! !

!B3DDemoSpheres methodsFor: 'demo9' stamp: 'BG 8/25/2002 17:33'!
createSolidsForScene9: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 3.0  z: 0.0).
	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Stick1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateCylinderFaces) asIndexedMesh.
     sceneObj texture: self gradientTexture.
     mat := B3DMaterial new.
	mat emission: (Color lightGray);
          shininess: 0.7;
         diffusePart: ("Color gray: 0.25" Color r: 0.6 g: 0.1 b: 0.7).
	mat ambientPart: (Color r:0.4 g: 0.7 b: 0.3).
	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.1 y: 1.5 z: 0.1)).
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.5  z: 0.0). 

	scene objects add: sceneObj.


	sceneObj _ B3DSceneObject named: 'Sphere2'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          specularPart: (Color gray: 0.99). 

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.7 y: 0.7 z: 0.7)).

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo9' stamp: 'BG 8/27/2002 05:04'!
descriptionScene9

  ^'Two white spheres without texture are connected by a stick with a gradient texture.
The source of this example shows how a scene is built from simple geometric objects, that are scaled and translated.'! !

!B3DDemoSpheres methodsFor: 'demo9' stamp: 'BG 9/2/2002 12:03'!
show9

    " B3DDemoSpheres new show9"

     | view |

  self createScene9.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene9;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view beRotating; openInSystemWindow.! !

!B3DDemoSpheres methodsFor: 'demo10' stamp: 'BG 9/2/2002 18:36'!
createLightsForScene10: aScene

	| ambientLight |

     ambientLight :=B3DAmbientLight new.	
	ambientLight lightColor: (B3DMaterialColor color: Color green).
	
	scene lights add: ambientLight.
! !

!B3DDemoSpheres methodsFor: 'demo10' stamp: 'BG 9/2/2002 18:26'!
createScene10

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@25.
	camera target: 0@0@0.
	camera fov: 9.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene10: scene;
          createLightsForScene10: scene.! !

!B3DDemoSpheres methodsFor: 'demo10' stamp: 'BG 9/2/2002 18:40'!
createSolidsForScene10: aScene

	| sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sphere1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     sceneObj texture: self gradientTextureForSphere.

     mat := B3DMaterial new.
	mat emission: (Color white);
          shininess: 0.7.
	mat ambientPart: (Color r:0.9 g: 0.9 b: 0.9).

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.5 y: 0.5 z: 0.5)).
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 3.0  z: 0.0).
	scene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Stick1'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateCylinderFaces) asIndexedMesh.
     sceneObj texture: self gradientTexture.
     mat := B3DMaterial new.
	mat emission: (Color white);
          shininess: 0.7.
	mat ambientPart: (Color r:0.9 g: 0.9 b: 0.9).
	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.1 y: 1.5 z: 0.1)).
     sceneObj geometry translateBy: (B3DVector3 x: 0.0  y: 1.5  z: 0.0). 

	scene objects add: sceneObj.


	sceneObj _ B3DSceneObject named: 'Sphere2'.
	sceneObj geometry: (B3DSimpleMesh withAll: B3DIndexedMesh vrmlCreateSphereFaces) asIndexedMesh.

     sceneObj texture: self gradientTextureForSphere2.

     mat := B3DMaterial new.
	mat shininess: 0.9;
          emission: Color white;
          ambientPart: (Color r:0.9 g: 0.9 b: 0.9).

	sceneObj material: mat.
     sceneObj geometry transformBy: (B3DMatrix4x4 identity setScale: (B3DVector3 x: 0.7 y: 0.7 z: 0.7)).

	scene objects add: sceneObj.! !

!B3DDemoSpheres methodsFor: 'demo10' stamp: 'BG 9/2/2002 18:42'!
descriptionScene10

  ^'Two white spheres with similar textures of different colors are connected by a stick with a gradient texture.
An ambient light and emission color white is sufficient to create a fairly good spacial impression.

The source of this example shows how a scene is built from simple geometric objects, that are scaled and translated.'! !

!B3DDemoSpheres methodsFor: 'demo10' stamp: 'BG 9/2/2002 18:26'!
show10

    " B3DDemoSpheres new show10"

     | view |

  self createScene10.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene10;
     scene: scene.
  view clearColor: (Color gray: 0.5).
  view rotateX: 25.4.
  view beRotating; openInSystemWindow.! !


!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 12:12'!
example1
   " B3DDemoSpheres example1"

    B3DDemoSpheres new show1! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 9/2/2002 18:43'!
example10
   " B3DDemoSpheres example10"

    B3DDemoSpheres new show10! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 12:12'!
example2
   " B3DDemoSpheres example2"

    B3DDemoSpheres new show2! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 12:13'!
example3
   " B3DDemoSpheres example3"

    B3DDemoSpheres new show3! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 14:27'!
example4
   " B3DDemoSpheres example4"

    B3DDemoSpheres new show4! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 14:27'!
example5
   " B3DDemoSpheres example5"

    B3DDemoSpheres new show5! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 14:27'!
example6
   " B3DDemoSpheres example6"

    B3DDemoSpheres new show6! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 16:15'!
example7
   " B3DDemoSpheres example7"

    B3DDemoSpheres new show7! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 17:36'!
example8
   " B3DDemoSpheres example8"

    B3DDemoSpheres new show8! !

!B3DDemoSpheres class methodsFor: 'examples' stamp: 'BG 8/25/2002 17:36'!
example9
   " B3DDemoSpheres example9"

    B3DDemoSpheres new show9! !


!B3DDemoSurfaces methodsFor: 'common methods' stamp: 'BG 8/25/2002 18:27'!
colorTilesWith: firstColor and: lastColor 
  " This method computes a texure with a chess board coloring. The texture has only four color field. It is designed for continuated use. "

  | form txt |

  form := Form extent: (32@ 32) depth: 32.
 
  form fill: (0 @ 0 extent: 16@16) fillColor: firstColor;
        fill: (16@16 extent: 16 @ 16) fillColor: firstColor;
        fill: (0 @ 16 extent: 16 @ 16) fillColor: lastColor;
        fill: (16 @ 0 extent: 16 @ 16) fillColor: lastColor.
  txt := form asTexture.
 
  txt wrap: false.
  txt interpolate: false.
  txt envMode: 0.
  ^txt! !

!B3DDemoSurfaces methodsFor: 'common methods' stamp: 'BG 9/10/2002 11:54'!
createQuadGeometry: fn 

  " here we create a QuadMesh. The scene is created elsewhere. "

   | nroPx nroPy stepPx stepPy x y
     low high xStart xStop yStart yStop idxF
     vtx face faces  mesh |

  nroPx := 48.  " number of points in direction x "
  nroPy := 48.  " number of points in direction y "
  xStart := 0.0.
  xStop  := 6.25.
  yStart := 0.0.
  yStop  := 6.25.
  stepPx := xStop - xStart / (nroPx - 1).
  stepPy := yStop - yStart / (nroPy - 1).
  
  vtx _ WriteStream on: (B3DVector3Array new: nroPx * nroPy).
  x := xStart.
  y := yStart.
    " compute the vertices "
  nroPx timesRepeat:
    [y := yStart.
     nroPy timesRepeat:
       [vtx nextPut: (B3DVector3 x: x y: (fn value: x value: y) z: y).
        y := y + stepPy.  
       ].
      x := x + stepPx. 
    ].

   "  create the quads "
   faces _ B3DIndexedQuadArray new: (nroPx - 1)*(nroPy - 1).
   idxF := low := 1.
	1 to: nroPx -1 do: [:i |
         high := low + nroPy.
		1 to: nroPy - 1 do: [:j |
			face _ B3DIndexedQuad 
						with: low + j - 1
						with: low + j
						with: high + j
						with: high + j - 1.
			faces at: idxF put: face.
              idxF := idxF + 1.
		].
        low := high.
      ].


   mesh := B3DIndexedQuadMesh new.
   mesh vertices: vtx contents;
          faces: faces.
   mesh vertexNormals.
  ^mesh
  ! !

!B3DDemoSurfaces methodsFor: 'common methods' stamp: 'BG 9/10/2002 11:52'!
createQuadGeometryAndTexture: fn 

  " here we create a QuadMesh. The scene is created elsewhere. "

   | nroPx nroPy stepPx stepPy x y xTexOrigin yTexOrigin
     low high xStart xStop yStart yStop idxF
     vtx face faces tex mesh |

  nroPx := 48.  " number of points in direction x "
  nroPy := 48.  " number of points in direction y "
  xStart := 0.0.
  xStop  := 6.25.
  yStart := 0.0.
  yStop  := 6.25.
  stepPx := xStop - xStart / (nroPx - 1).
  stepPy := yStop - yStart / (nroPy - 1).

 
   vtx := WriteStream on: (B3DVector3Array new: nroPx * nroPy).
  x := xStart.
  y := yStart.
    " compute the vertices "
  nroPx timesRepeat:
    [y := yStart.
     nroPy timesRepeat:
       [vtx nextPut: (B3DVector3 x: x y: (fn value: x value: y) z: y).
        y := y + stepPy.  
       ].
      x := x + stepPx. 
    ].

    " define the texture "
     yTexOrigin := 0.0.
    tex _ WriteStream on: (B3DTexture2Array new: nroPx * nroPy).
 
   1 to: nroPx do:[:xx | xTexOrigin := 0.0.
        1 to: nroPy do: [:idx | 
               tex nextPut:  xTexOrigin @ yTexOrigin.
               xTexOrigin := xTexOrigin + 0.5.
		].
      yTexOrigin := yTexOrigin + 0.5
   ].
   "  create the quads "
   faces _ B3DIndexedQuadArray new: (nroPx - 1)*(nroPy - 1).
   idxF := low := 1.
	1 to: nroPx -1 do: [:i |
         high := low + nroPy.
		1 to: nroPy - 1 do: [:j |
			face _ B3DIndexedQuad 
						with: low + j - 1
						with: low + j
						with: high + j
						with: high + j - 1.
			faces at: idxF put: face.
              idxF := idxF + 1.
		].
        low := high.
      ].


   mesh := B3DIndexedQuadMesh new.
   mesh vertices: vtx contents;
          texCoords: tex contents;
           faces: faces.
 
  mesh vertexNormals.
  ^mesh
  ! !

!B3DDemoSurfaces methodsFor: 'common methods' stamp: 'BG 9/10/2002 11:51'!
createTriangleGeometryAndTexture: fn 

  " here we create a QuadMesh. The scene is created elsewhere. "

   | nroPx nroPy stepPx stepPy x y xTexOrigin yTexOrigin
     low high xStart xStop yStart yStop idxF
     vtx face faces tex mesh |

  nroPx := 48.  " number of points in direction x "
  nroPy := 48.  " number of points in direction y "
  xStart := 0.0.
  xStop  := 6.25.
  yStart := 0.0.
  yStop  := 6.25.
  stepPx := xStop - xStart / (nroPx - 1).
  stepPy := yStop - yStart / (nroPy - 1).
  
  vtx _ WriteStream on: (B3DVector3Array new: nroPx * nroPy).
  x := xStart.
  y := yStart.
    " compute the vertices "
  nroPx timesRepeat:
    [y := yStart.
     nroPy timesRepeat:
       [vtx nextPut: (B3DVector3 x: x y: (fn value: x value: y) z: y).
        y := y + stepPy.  
       ].
      x := x + stepPx. 
    ].

    " define the texture "
     yTexOrigin := 0.0.
    tex _ WriteStream on: (B3DTexture2Array new: nroPx * nroPy).
 
   1 to: nroPx do:[:xx | xTexOrigin := 0.0.
        1 to: nroPy do: [:idx | 
               tex nextPut:  xTexOrigin @ yTexOrigin.
               xTexOrigin := xTexOrigin + 0.5.
		].
      yTexOrigin := yTexOrigin + 0.5
    ].
   "  create the triangles "
     faces := B3DIndexedTriangleArray new: (nroPx - 1)*(nroPy - 1)*2.  

   idxF := low := 1.
   1 to: nroPx -1 do: [:i |
      high := low + nroPy.
      1 to: nroPy - 1 do: [:j |
         face := B3DIndexedTriangle 
                   with: low + j - 1
                   with: low + j
                   with: high + j.
         faces at: idxF put: face.
         idxF := idxF + 1.
         face := B3DIndexedTriangle 
                   with: low + j - 1
                   with: high + j
                   with: high + j - 1.
         faces at: idxF put: face.
         idxF := idxF + 1.
        ].
      low := high.
     ].


   mesh := B3DIndexedTriangleMesh  new.
   mesh vertices: vtx contents;
          texCoords: tex contents;
        " vertexNormals: vtxNormals; "
          faces: faces.
  mesh vertexNormals.
  ^mesh
  ! !

!B3DDemoSurfaces methodsFor: 'common methods' stamp: 'BG 8/25/2002 15:08'!
surface1

  ^[:x :y | 1 - x sin * (2 - (y * 2) cos) / 2]! !

!B3DDemoSurfaces methodsFor: 'common methods' stamp: 'BG 8/25/2002 15:08'!
surface2

  ^[:x :y | 2 + x sin * (1 + (y * 2) cos)/2]! !

!B3DDemoSurfaces methodsFor: 'demo1' stamp: 'BG 8/25/2002 15:09'!
createLightsForScene1: aScene


	| ambientLight |

     ambientLight :=B3DAmbientLight new.	
	ambientLight lightColor: (B3DMaterialColor color: Color white).
	
	aScene lights add: ambientLight.! !

!B3DDemoSurfaces methodsFor: 'demo1' stamp: 'BG 9/11/2002 14:48'!
createScene1

	| camera |

	camera _ B3DCamera new.
	camera position: 20@0@20.
	camera fov: 12.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene1: scene;
          createLightsForScene1: scene.

	camera target: scene boundingBox center.
! !

!B3DDemoSurfaces methodsFor: 'demo1' stamp: 'BG 8/25/2002 18:24'!
createSolidsForScene1: aScene

	| sceneObj |

	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: (self createQuadGeometryAndTexture: self surface1).
     sceneObj texture: (self colorTilesWith: (Color r: 0.6 g: 0.1 b: 0.0)
                                  and: (Color r: 0.95 g: 0.1 b: 0.0)). 

	aScene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Surface2'.
	sceneObj geometry: (self createQuadGeometryAndTexture: self surface2).
     sceneObj texture: (self colorTilesWith: (Color r: 0.0 g: 0.65 b: 0.0)
                                  and: (Color r: 0.0 g: 0.95 b: 0.0)).

	aScene objects add: sceneObj.! !

!B3DDemoSurfaces methodsFor: 'demo1' stamp: 'BG 9/10/2002 16:45'!
createTriangleGeometry: fn withDerivatives: dufn and: dvfn
 uFrom: xStart to: xStop vFrom: yStart to: yStop
        divisionU: nroPx divisionV: nroPy
        coloring: aBlock
  " here we create a triangle mesh. The scene is created elsewhere. "

   |  stepPx stepPy x y
     low high idxF
     vtx face faces mesh vtxNormals vtxColors fnValue |

  stepPx := xStop - xStart / (nroPx - 1).
  stepPy := yStop - yStart / (nroPy - 1).
  
  vtx _ WriteStream on: (B3DVector3Array new: nroPx * nroPy).
  dufn notNil
    ifTrue: [vtxNormals _ WriteStream on: (B3DVector3Array new: nroPx * nroPy)].
  aBlock notNil ifTrue:
    [vtxColors := WriteStream on: (B3DColor4Array new: nroPx * nroPy)].
  x := xStart.
  y := yStart.
    " compute the vertices "
  nroPx timesRepeat:
    [y := yStart.
     nroPy timesRepeat:
       [vtx nextPut: (B3DVector3 x: x y: (fnValue := fn value: x value: y) z: y).
        dufn notNil
           ifTrue: [vtxNormals nextPut:
                    (B3DVector3 x: (dufn value: x value: y)
                                  y: -1.0
                                  z: (dvfn value: x value: y)) safelyNormalized].
        aBlock notNil
           ifTrue: [vtxColors nextPut: (aBlock value: x - xStart/(xStop - xStart)
                                                    value: y - yStart/(yStop - yStart)
                                                    value: fnValue)].
        y := y + stepPy.  
       ].
      x := x + stepPx. 
    ].

     faces := B3DIndexedTriangleArray new: (nroPx - 1)*(nroPy - 1)*2.  

   idxF := low := 1.
   1 to: nroPx -1 do: [:i |
      high := low + nroPy.
      1 to: nroPy - 1 do: [:j |
         face := B3DIndexedTriangle 
                   with: low + j - 1
                   with: low + j
                   with: high + j.
         faces at: idxF put: face.
         idxF := idxF + 1.
         face := B3DIndexedTriangle 
                   with: low + j - 1
                   with: high + j
                   with: high + j - 1.
         faces at: idxF put: face.
         idxF := idxF + 1.
        ].
      low := high.
     ].



   mesh := B3DIndexedTriangleMesh new.
   mesh vertices: vtx contents;
          faces: faces.
   dufn notNil
     ifTrue: [mesh vertexNormals: vtxNormals contents].
   aBlock notNil
     ifTrue: [mesh vertexColors: vtxColors contents].
 
  ^mesh
  ! !

!B3DDemoSurfaces methodsFor: 'demo1' stamp: 'BG 9/11/2002 10:50'!
descriptionScene1

  ^'Two intersecting surfaces are drawn. Both surfaces are drawn with textures. A white ambient light is used to illuminate the scene. (White light was choosen to ensure that the textures are displayed with their true colors. Use of colored light would change the texture colors.)
In the presence of ambient light we do not need to add materials to the surfaces.
Equations of the surfaces:
(1 - sin(x))*(2 - cos(2*y))/2
(2 + sin(x))*(1 + cos(2*y))/2

The example uses textures with only four colored fields. To cover the entire  surface, the texture is continued. 
In method createScene1  the statement
camera target: scene boundingBox center.
causes the camera to look at the center of the scene.'! !

!B3DDemoSurfaces methodsFor: 'demo1' stamp: 'BG 9/2/2002 12:20'!
show1

    " B3DDemoSurfaces new show1"

     | view |

  self createScene1.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene1;
     scene: scene.
  view clearColor: (Color gray: 0.7).

  view rotateZ: 12.0.
  view openInSystemWindow.! !

!B3DDemoSurfaces methodsFor: 'demo2' stamp: 'BG 9/11/2002 09:49'!
createLightsForScene2: aScene


	| light1 light2 light3 |

	light1 := B3DSpotLight new.
     light1 position: 20 @ 0 @ 0;
             direction: 20 negated @ 0 @ 0;
             target: 0 @ 0 @ 0.
     light1 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.2).
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
     light1 minAngle: 30;
             maxAngle: 50.
	aScene lights add: light1.

	light2 := B3DSpotLight new.
     light2 position: (120 degreesToRadians cos) * 20  @ (120 degreesToRadians sin * 20) @ 2;
             direction: (120 degreesToRadians cos) * 20 negated  @ (120 degreesToRadians sin * 20 negated) @ -2;
             target: 0 @ 0 @ 0.
     light2 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
     light2 minAngle: 30;
             maxAngle: 50.
	aScene lights add: light2.

	light3 := B3DSpotLight new.
     light3 position: (240 degreesToRadians cos) * 20  @ (240 degreesToRadians sin * 20) @ 2;
             direction: (240 degreesToRadians cos) * 20 negated @ (240 degreesToRadians sin * 20 negated) @ -2;
             target: 0 @ 0 @ 0.
     light3 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
     light3 minAngle: 50;
             maxAngle: 70.
	aScene lights add: light3.! !

!B3DDemoSurfaces methodsFor: 'demo2' stamp: 'BG 9/11/2002 14:48'!
createScene2

	| camera |

	camera _ B3DCamera new.
	camera position: 20@0@20.
	camera fov: 12.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene2: scene;
          createLightsForScene7: scene.

	camera target: scene boundingBox center.! !

!B3DDemoSurfaces methodsFor: 'demo2' stamp: 'BG 9/11/2002 15:36'!
createSolidsForScene2: aScene

	| sceneObj mat |

   
	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: (self createQuadGeometryAndTexture: self surface1).
     sceneObj texture: (self colorTilesWith: (Color r: 0.7 g: 0.7 b: 0.2)
                                  and: (Color r: 0.8 g: 0.8 b: 0.3)). 

     mat := B3DMaterial new.
	mat shininess: 0.9;
          emission: (Color gray: 0.25);
          specularPart: (Color white). 
     sceneObj material: mat.

	aScene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Surface2'.
	sceneObj geometry: (self createQuadGeometryAndTexture: self surface2).
     sceneObj texture: (self colorTilesWith: (Color r: 0.7 g: 0.7 b: 0.7)
                                  and: (Color r: 0.8 g: 0.8 b: 0.8)). 
     mat := B3DMaterial new.
	mat shininess: 0.7;
          emission: (Color gray: 0.25);
          specularPart: (Color gray: 0.99). 

     sceneObj material: mat.

	aScene objects add: sceneObj.! !

!B3DDemoSurfaces methodsFor: 'demo2' stamp: 'BG 9/11/2002 10:11'!
descriptionScene2

  ^'Two intersecting surfaces are drawn. Quadmeshes are used. Both surfaces are drawn with textures. Spotlights are used to illuminate the scene. To use spotlights, the mesh must have vertex normals.'! !

!B3DDemoSurfaces methodsFor: 'demo2' stamp: 'BG 9/11/2002 10:36'!
show2

    " B3DDemoSurfaces new show2"

     | view |

  self createScene2.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene2;
     scene: scene.
  view clearColor: (Color gray: 0.88).

  view rotateZ: 12.0.
  view openInSystemWindow.! !

!B3DDemoSurfaces methodsFor: 'demo3' stamp: 'BG 9/11/2002 09:57'!
createLightsForScene3: aScene


	| light1 light2 light3 |
	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ 0 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.38 b: 0.2)).
	scene lights add: light1.

	light1 := B3DDirectionalLight new.
	light1 direction: -100 @ -50 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.65 b: 0.45)).
	scene lights add: light1.


	light1 := B3DSpotLight new.
     light1 position: 20 @ 10 @ 0;
             direction: 20 negated @ -10 @ 0;
             target: scene boundingBox center.
     light1 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.2).
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.8 g: 0.15 b: 0.15)).
     light1 minAngle: 30;
             maxAngle: 50.
	aScene lights add: light1.

	light2 := B3DSpotLight new.
     light2 position: (120 degreesToRadians cos) * 20  @ (120 degreesToRadians sin * 20) @ 0;
             direction: (120 degreesToRadians cos) * 20 negated  @ (120 degreesToRadians sin * 20 negated) @ 0;
             target: scene boundingBox center.
     light2 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.8 b: 0.15)).
     light2 minAngle: 30;
             maxAngle: 50.
	aScene lights add: light2.

	light3 := B3DSpotLight new.
     light3 position: (240 degreesToRadians cos) * 20  @ (240 degreesToRadians sin * 20) @ 0;
             direction: (240 degreesToRadians cos) * 20 negated @ (240 degreesToRadians sin * 20 negated) @ 0;
             target: scene boundingBox center.
     light3 attenuation: (B3DLightAttenuation constant: 1.0 linear: 0.5 squared: 0.0).
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.15 g: 0.15 b: 0.8)).
     light3 minAngle: 50;
             maxAngle: 70.
	aScene lights add: light3.! !

!B3DDemoSurfaces methodsFor: 'demo3' stamp: 'BG 9/11/2002 14:35'!
createScene3

	| camera |

	camera _ B3DCamera new.
	camera position: 20@0@20.
	camera fov: 12.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene3: scene;
          createLightsForScene3: scene.

	camera target: scene boundingBox center.! !

!B3DDemoSurfaces methodsFor: 'demo3' stamp: 'BG 9/11/2002 10:45'!
createSolidsForScene3: aScene

	| sceneObj mat |

   
	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: (self createTriangleGeometryAndTexture: self surface1).
     sceneObj texture: (self colorTilesWith: (Color r: 0.7 g: 0.7 b: 0.7)
                                  and: (Color r: 0.8 g: 0.8 b: 0.7)). 

     mat := B3DMaterial new.
	mat shininess: 0.9;
          emission: (Color gray: 0.25);
          specularPart: (Color white). 
     sceneObj material: mat.

	aScene objects add: sceneObj.

	sceneObj _ B3DSceneObject named: 'Surface2'.
	sceneObj geometry: (self createTriangleGeometryAndTexture: self surface2).
     sceneObj texture: (self colorTilesWith: (Color r: 0.7 g: 0.7 b: 0.7)
                                  and: (Color r: 0.8 g: 0.8 b: 0.8)).  
     mat := B3DMaterial new.
	mat shininess: 0.7;
          emission: (Color gray: 0.25);
          specularPart: (Color gray: 0.99). 

     sceneObj material: mat.

	aScene objects add: sceneObj.! !

!B3DDemoSurfaces methodsFor: 'demo3' stamp: 'BG 9/11/2002 10:58'!
descriptionScene3

  ^'Two intersecting surfaces are drawn. Triangular meshes are used for both surfaces. Both surfaces are drawn with textures. Two directional lights and three spotlights are used to illuminate the scene. 

Surface coloring with lights requires the computation of vertex normals.

Proposal for further work:
Remove the textures (in method createSolidForScene3:). It is also a nice idea to draw one surface with texture and one without.'! !

!B3DDemoSurfaces methodsFor: 'demo3' stamp: 'BG 9/11/2002 09:56'!
show3

    " B3DDemoSurfaces new show3"

     | view |

  self createScene3.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene3;
     scene: scene.
  view clearColor: (Color gray: 0.86).

  view rotateZ: 12.0.
  view openInSystemWindow! !

!B3DDemoSurfaces methodsFor: 'demo4' stamp: 'BG 9/7/2002 11:56'!
createLightsForScene4: aScene

   | headLight light3 light4 |

	headLight := B3DSpotLight new.
	headLight position: 10@0@10.
     headLight direction: 1 @ 0 @ 0.
	headLight target: 0@0@0.
	headLight lightColor: (B3DMaterialColor color: (Color white)).
	headLight attenuation: (B3DLightAttenuation constant: 1.0 linear: 1.0 squared: 0.0).
	headLight minAngle: 50.
	headLight maxAngle: 60.
     aScene lights add: headLight.
  

     light3 := B3DSpotLight new.
     light3 position: 10 @ 3.0 @ 0; 
             direction: 1 @ 2 @ 1;
          target: 0 @ 0 @ 0;
             lightColor: (B3DMaterialColor color: Color green).
    light3 minAngle: 10;
            maxAngle: 70.
    light3  attenuation: (B3DLightAttenuation constant: 1.0 linear: 1.0 squared: 0.0).
    aScene lights add: light3. 

     light4 := B3DSpotLight new.
     light4 position: 0.0 @ 4.0 @ 10.0; 
             direction: 10 @ 10 @ 10;
          target: 0 @ 0 @ 0;
             lightColor: (B3DMaterialColor color: Color red).
    light4 minAngle: 50;
            maxAngle: 90.
    light4  attenuation: (B3DLightAttenuation constant: 1.0 linear: 1.0 squared: 0.0).
    aScene lights add: light4.
! !

!B3DDemoSurfaces methodsFor: 'demo4' stamp: 'BG 9/10/2002 12:10'!
createScene4

	| camera |

	camera _ B3DCamera new.
	camera position: 20@0@20.
	camera fov: 16.0.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene4: scene;
          createLightsForScene4: scene.

	camera target: scene boundingBox center.! !

!B3DDemoSurfaces methodsFor: 'demo4' stamp: 'BG 9/10/2002 12:10'!
createSolidsForScene4: aScene

     | sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Surface1'.
	sceneObj geometry: (self createQuadGeometry: [:x :y |  2 + (2*x) sin * (1 + (y * 2) cos) *2 / 3]).

     mat := B3DMaterial new.
	mat emission: (Color r: 0.7 g: 0.6 b: 0.3);
          shininess: 0.9";
         diffusePart: ( Color r: 0.6 g: 0.3 b: 0.2).
	mat ambientPart: (Color r:0.5 g: 0.7 b: 0.3)".
     mat specularPart: Color white. 
	sceneObj material: mat.

	scene objects add: sceneObj.

! !

!B3DDemoSurfaces methodsFor: 'demo4' stamp: 'BG 8/25/2002 21:25'!
descriptionScene4

  ^'A surface is drawn. A quadrangular mesh is used. No texture is used.'! !

!B3DDemoSurfaces methodsFor: 'demo4' stamp: 'BG 9/7/2002 11:56'!
show4

    " B3DDemoSurfaces new show4"

     | view |

  self createScene4.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene4;
     scene: scene.
  view clearColor: (Color gray: 0.7).

  view rotateZ: 12.0.
  view openInSystemWindow! !

!B3DDemoSurfaces methodsFor: 'demo5' stamp: 'BG 9/10/2002 11:59'!
computeGeometry3x: aBlockX y: aBlockY z: aBlockZ uFrom: u1 to: u2 vFrom: v1 to: v2
divisionU: gridU divisionV: gridV

   "  compute the mesh for a surface that is defined by three functions of two parameters. "
 

	| vtx face dU dV vertices faces  mesh tex xTexOrigin yTexOrigin low high |
   
    dU := u2 - u1 / (gridU - 1).  " gridU, gridV is the number of points "
    dV := v2 - v1 / (gridV - 1).
	vtx _ WriteStream on: (B3DVector3Array new": gridU * gridV").
  	0 to: gridU - 1 do:[:idU | | u | 
                 u := dU * idU + u1.
		0 to: gridV - 1 do:[:idV| | v x y fn |
               v := dV * idV + v1.
               x := aBlockX value: u value: v.
               y := aBlockY value: u value: v.
               fn := aBlockZ value: u value: v.
			vtx nextPut: (B3DVector3 x: x asFloat  y: y asFloat  z: fn asFloat ).
 		].
	].

     " define the texture "
       yTexOrigin := 0.0.
     tex _ WriteStream on: (B3DTexture2Array new).
   	0 to: gridU - 1 do:[:x| xTexOrigin := 0.0.
        0 to: gridV - 1 do: [:idx| 
               tex nextPut:  xTexOrigin @ yTexOrigin.
               xTexOrigin := xTexOrigin + 0.5.
		].
      yTexOrigin := yTexOrigin + 0.5
   ].

	vertices _ vtx contents.
   
	faces _ WriteStream on: (B3DIndexedQuadArray new).
     low := 1.
	1 to: gridU -1 do:[:i|
         high := low + gridV.
		1 to: gridV - 1 do:[:j|
			face _ B3DIndexedQuad 
						with: low + j - 1
						with: low + j
						with: high + j
						with: high + j - 1.
			faces nextPut: face.
		].
        low := high.
 ].
   mesh := B3DIndexedQuadMesh new.
   mesh vertices: vertices;
          faces: faces contents;
          texCoords: tex contents.
   mesh vertexNormals.
  ^mesh! !

!B3DDemoSurfaces methodsFor: 'demo5' stamp: 'BG 8/25/2002 21:40'!
createLightsForScene5: aScene

   | light |
     light :=B3DAmbientLight new.
	
	light lightColor: (B3DMaterialColor color: (Color yellow)).
	
	scene lights add: light.
! !

!B3DDemoSurfaces methodsFor: 'demo5' stamp: 'BG 8/25/2002 21:50'!
createScene5

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-100.
	camera target: 0@0@0.
	camera fov: 4.5.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene5: scene;
          createLightsForScene5: scene.

! !

!B3DDemoSurfaces methodsFor: 'demo5' stamp: 'BG 9/8/2002 08:28'!
createSolidsForScene5: aScene

     | sceneObj |

	sceneObj _ B3DSceneObject named: 'Sample Cube'.
	sceneObj geometry:
          (self computeGeometry3x:  [:u1 :v1 | v1 cos*2 + (0.5*(u1 cos*(v1 cos) negated + (u1 sin*v1 sin/2.0/2.236068)))]
                        y: [:u3 :v3 | u3 sin / 2.236068 + (v3/2.0)]
                        z: [:u2 :v2 | v2 sin * 2.0 + (0.5*(v2 sin*(u2 cos) negated - ((u2 sin*v2 cos / 2/2.236068))))]
                        uFrom: Float pi negated  to: Float pi
                        vFrom: -3.0 * Float pi to: 3.0 *Float pi
                        divisionU: 15
                        divisionV: 200
          ).
     sceneObj texture: (self colorTilesWith: (Color r: 0.0 g: 0.8 b: 0.0)
                                and: (Color r: 0.0 g: 0.55 b: 0.0)).
	scene objects add: sceneObj.

! !

!B3DDemoSurfaces methodsFor: 'demo5' stamp: 'BG 8/25/2002 21:48'!
descriptionScene5

  ^'A helix is drawn. A quadrangular mesh and a texture are used. A yellow ambient light is used. Materials are not needed, the texture is sufficient.'! !

!B3DDemoSurfaces methodsFor: 'demo5' stamp: 'BG 9/4/2002 13:41'!
show5

    " B3DDemoSurfaces new show5"

     | view |

  self createScene5.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene5;
     scene: scene.
  view clearColor: (Color gray: 0.86).

  
  view openInSystemWindow! !

!B3DDemoSurfaces methodsFor: 'demo6' stamp: 'BG 9/10/2002 16:26'!
computeGeometry6x: aBlockX y: aBlockY z: aBlockZ uFrom: u1 to: u2 vFrom: v1 to: v2
divisionU: gridU divisionV: gridV

   "  compute the mesh for a surface that is defined by three functions of two parameters. "
 

	| vtx face dU dV vertices faces mesh low high vtxColors idxF |
   
    dU := u2 - u1 / (gridU - 1).  " gridU, gridV is the number of points "
    dV := v2 - v1 / (gridV - 1).
	vtx _ WriteStream on: (B3DVector3Array new).
     vtxColors := WriteStream on: B3DColor4Array new.
  	0 to: gridU - 1 do:
        [:idU | | u | 
          u := dU * idU + u1.
          0 to: gridV - 1 do:[:idV | | v x y fn |
               v := dV * idV + v1.
               x := aBlockX value: u value: v.
               y := aBlockY value: u value: v.
               fn := aBlockZ value: u value: v.
			vtx nextPut: (B3DVector3 x: x asFloat  y: y asFloat  z: fn asFloat).
               vtxColors nextPut: (Color h: 360*(v - v1)/(v2 -  v1)
                                            s: 0.6*((u - u1) abs min: (u - u2) abs)/(u2 -  u1) + 0.4
                                            v: -0.6*((u - u1) abs min: (u - u2) abs)/(u2 -  u1) + 1.0) asB3DColor
 		].
	].


	vertices _ vtx contents.
   
	faces _ B3DIndexedTriangleArray new: (gridU - 1)*(gridV - 1)*2.
     idxF := 0.
     low := 1.
	1 to: gridU -1 do:[:i |
         high := low + gridV.
		1 to: gridV - 1 do:[:j |
			face _ B3DIndexedTriangle 
						with: low + j - 1
						with: low + j
						with: high + j
						"with: high + j - 1".
			faces at: (idxF := idxF + 1) put: face.

              face := B3DIndexedTriangle 
                        with: low + j - 1
                        "with: low + j"
                        with: high + j
                        with: high + j - 1.
			faces at: (idxF := idxF + 1) put: face.

		].
        low := high.
 ].
   mesh := B3DIndexedTriangleMesh new.
   mesh vertices: vertices;
          faces: faces;
          vertexColors: vtxColors contents.
  ^mesh! !

!B3DDemoSurfaces methodsFor: 'demo6' stamp: 'BG 9/4/2002 13:43'!
createLightsForScene6: aScene

   | light |
     light :=B3DAmbientLight new.
	
	light lightColor: (B3DMaterialColor color: (Color white)).
	
	aScene lights add: light.! !

!B3DDemoSurfaces methodsFor: 'demo6' stamp: 'BG 9/4/2002 13:42'!
createScene6

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-100.
	camera target: 0@0@0.
	camera fov: 4.5.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene6: scene;
          createLightsForScene6: scene.! !

!B3DDemoSurfaces methodsFor: 'demo6' stamp: 'BG 9/8/2002 08:27'!
createSolidsForScene6: aScene

     | sceneObj |

	sceneObj _ B3DSceneObject named: 'Sample Cube'.
	sceneObj geometry:
          (self computeGeometry6x: [:u1 :v1 | v1 cos*2 + (0.5*(u1 cos*(v1 cos) negated + (u1 sin*v1 sin/2.0/2.236068)))]
                        y: [:u3 :v3 | u3 sin / 2.236068 + (v3/2.0)]
                        z: [:u2 :v2 | v2 sin * 2.0 + (0.5*(v2 sin*(u2 cos) negated - ((u2 sin*v2 cos / 2/2.236068))))]
                        uFrom: Float pi negated  to: Float pi
                        vFrom: -3.0 * Float pi to: 3.0 *Float pi
                        divisionU: 15
                        divisionV: 200
          ).
	aScene objects add: sceneObj.
! !

!B3DDemoSurfaces methodsFor: 'demo6' stamp: 'BG 9/4/2002 17:06'!
descriptionScene6

  ^'A helix is drawn. A triangular mesh and vertex coloring are used together with a white ambient light.

The example shows that vertex coloration can be used to visualize an additional parameter - in the example the arc length of the helix.

This solid rotates very slowly. This is an indication that rendering of meshes with colored vertices is time consuming.'! !

!B3DDemoSurfaces methodsFor: 'demo6' stamp: 'BG 9/4/2002 17:04'!
show6

    " B3DDemoSurfaces new show6"

     | view |

  self createScene6.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene6;
     scene: scene.
  view clearColor: (Color gray: 0.86).

  
  view addFrameAndExplanationField openInWorldExtent: Display extent x//2 @ (Display extent y * 7 // 8).! !

!B3DDemoSurfaces methodsFor: 'demo7' stamp: 'BG 9/10/2002 10:20'!
createLightsForScene7: aScene

	| light1 light2 light3 light4 |

	light1 := B3DDirectionalLight new.
	light1 direction: 100 @ -20 @ 0.
     light1 lightColor: (B3DMaterialColor color: (Color r: 0.75 g: 0.28 b: 0.28)).
	scene lights add: light1.

	light2 := B3DDirectionalLight new.
	light2 direction: (240 degreesToRadians cos) * 100 @ -20 @ (240 degreesToRadians sin * 100).
     light2 lightColor: (B3DMaterialColor color: (Color r: 0.25 g: 0.8 b: 0.25)).
	scene lights add: light2.

	light3 := B3DDirectionalLight new.
	light3 direction: (120 degreesToRadians cos) * 100 @ -20 @ (120 degreesToRadians sin * 100).
     light3 lightColor: (B3DMaterialColor color: (Color r: 0.25 g: 0.25 b: 0.8)).
	scene lights add: light3.

	light4 := B3DDirectionalLight new.
	light4 direction: 0 @ -100 @ -10.
     light4 lightColor: (B3DMaterialColor color: (Color r: 0.3 g: 0.3 b: 0.02)).
	scene lights add: light4.
! !

!B3DDemoSurfaces methodsFor: 'demo7' stamp: 'BG 9/10/2002 10:03'!
createScene7

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-50.
	camera target: 0@0@0.
	camera fov: 2.5.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene7: scene;
          createLightsForScene7: scene.! !

!B3DDemoSurfaces methodsFor: 'demo7' stamp: 'BG 9/10/2002 16:31'!
createSolidsForScene7: aScene

     | sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sample Cube'.
	sceneObj geometry:
          (self createTriangleGeometry: [:x :y | (x*x + (y*y)) negated exp * x * 4.0]
                        withDerivatives: [:u1 :v1 | (u1*u1 + (v1*v1)) negated exp *  4.0 - ((u1*u1 + (v1*v1)) negated exp * u1 *u1* 8.0)]
                        and: [:u1 :v1 | ((u1*u1 + (v1*v1)) negated exp * u1 *v1* -8.0)]
                        uFrom: -2.0 to:2.0
                        vFrom: -2.0 to: 2.5
                        divisionU: 38
                        divisionV: 42
                        coloring: nil 
          ).

     mat := B3DMaterial new.
	mat shininess: 0.9;
          emission: (Color gray: 0.22);
          specularPart: (Color gray: 0.8). 

	sceneObj material: mat.

	aScene objects add: sceneObj.! !

!B3DDemoSurfaces methodsFor: 'demo7' stamp: 'BG 9/10/2002 16:12'!
descriptionScene7

  ^'The profile of the function f(x, y) := 4*x*exp(-x^2 - y^2)  is drawn. The profile is approximated by a triangular mesh with geometrically correct vertex normals. Four directed lights of different color are used to color the surface that is dark gray but reflects light of all colors.'! !

!B3DDemoSurfaces methodsFor: 'demo7' stamp: 'BG 9/10/2002 09:57'!
show7

    " B3DDemoSurfaces new show7"

     | view |

  self createScene7.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene7;
     scene: scene.
  view rotateX: 12.0.
  view clearColor: (Color gray: 0.86).

  
  view addFrameAndExplanationField openInWorldExtent: Display extent x//2 @ (Display extent y * 7 // 8).! !

!B3DDemoSurfaces methodsFor: 'demo8' stamp: 'BG 9/10/2002 16:13'!
createLightsForScene8: aScene

   | light |
     light :=B3DAmbientLight new.
	
	light lightColor: (B3DMaterialColor color: (Color white)).
	
	aScene lights add: light.! !

!B3DDemoSurfaces methodsFor: 'demo8' stamp: 'BG 9/10/2002 16:13'!
createScene8

	| camera |

	camera _ B3DCamera new.
	camera position: 0@0@-50.
	camera target: 0@0@0.
	camera fov: 2.5.

	scene _ B3DScene new.
	scene defaultCamera: camera.

     self createSolidsForScene8: scene;
          createLightsForScene8: scene.! !

!B3DDemoSurfaces methodsFor: 'demo8' stamp: 'BG 9/10/2002 16:51'!
createSolidsForScene8: aScene

     | sceneObj mat |

	sceneObj _ B3DSceneObject named: 'Sample Cube'.
	sceneObj geometry:
          (self createTriangleGeometry: [:x :y | (x*x + (y*y)) negated exp * x * 4.0]
                        withDerivatives: nil
                        and: nil
                        uFrom: -2.0 to:2.0
                        vFrom: -2.0 to: 2.5
                        divisionU: 38
                        divisionV: 42
                        coloring: [:x :y :f | (Color h: 360*x
                                            s: 0.5*y + 0.5
                                            v: -0.6*y + 1.0) asB3DColor ] 
          ).

     mat := B3DMaterial new.
	mat shininess: 0.9;
          emission: (Color gray: 0.22). 

	sceneObj material: mat.

	aScene objects add: sceneObj.! !

!B3DDemoSurfaces methodsFor: 'demo8' stamp: 'BG 9/10/2002 17:12'!
descriptionScene8

  ^'The profile of the function f(x, y) := 4*x*exp(-x^2 - y^2)  is drawn. The profile is approximated by a triangular mesh. Vertex coloring is used to color the surface. Vertex normals are not needed. A white ambient light is used.

The body has a dark gray as its own color. You can remove the material (in method createSolidsForScene8:), the body becomes than darker. The use of a material demonstrates the combination of vertex coloring with material properties.'! !

!B3DDemoSurfaces methodsFor: 'demo8' stamp: 'BG 9/10/2002 16:12'!
show8

    " B3DDemoSurfaces new show8"

     | view |

  self createScene8.
  (view := B3DTutorialScenePresenterMorph new)
     source: self description: #descriptionScene8;
     scene: scene.
  view rotateX: 12.0.
  view clearColor: (Color gray: 0.86).

  
  view addFrameAndExplanationField openInWorldExtent: Display extent x//2 @ (Display extent y * 7 // 8).! !


!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 8/25/2002 21:16'!
example1

   " B3DDemoSurfaces example1."


    B3DDemoSurfaces new show1.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 8/25/2002 21:16'!
example2

   " B3DDemoSurfaces example2."


    B3DDemoSurfaces new show2.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 8/25/2002 21:16'!
example3

   " B3DDemoSurfaces example3."


    B3DDemoSurfaces new show3.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 8/25/2002 21:28'!
example4

   " B3DDemoSurfaces example4."


    B3DDemoSurfaces new show4.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 9/4/2002 14:57'!
example5

   " B3DDemoSurfaces example5."


    B3DDemoSurfaces new show5.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 9/4/2002 14:57'!
example6

   " B3DDemoSurfaces example6."


    B3DDemoSurfaces new show6.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 9/10/2002 10:19'!
example7

   " B3DDemoSurfaces example7."


    B3DDemoSurfaces new show7.
   ! !

!B3DDemoSurfaces class methodsFor: 'examples' stamp: 'BG 9/10/2002 16:58'!
example8

   " B3DDemoSurfaces example8."


    B3DDemoSurfaces new show8.
   ! !


!B3DDirectionalLight methodsFor: 'as yet unclassified' stamp: 'BG 8/25/2002 01:25'!
direction
	^direction! !

!B3DDirectionalLight methodsFor: 'as yet unclassified' stamp: 'BG 8/25/2002 01:24'!
direction: aVector
	direction _ aVector! !


!B3DIndexedQuad methodsFor: 'accessing' stamp: 'BG 8/24/2002 21:39'!
p1Index

   ^self at: 1! !

!B3DIndexedQuad methodsFor: 'accessing' stamp: 'BG 8/24/2002 21:39'!
p2Index

   ^self at: 2! !

!B3DIndexedQuad methodsFor: 'accessing' stamp: 'BG 8/24/2002 21:39'!
p3Index

   ^self at: 3! !

!B3DIndexedQuad methodsFor: 'accessing' stamp: 'BG 8/24/2002 21:39'!
p4Index

   ^self at: 4! !


!B3DRegularSolid methodsFor: 'accessing' stamp: 'BG 8/29/2002 21:03'!
setFaceColors: aCollection

   faceColors := aCollection.

  ! !

!B3DRegularSolid methodsFor: 'accessing' stamp: 'BG 9/9/2002 10:39'!
setVertexColors: aCollection

  "  the following condition is required to hold:
     vertexColors size = faces size
       and: [(1 to: faces size) allSatisfy:
                 [:idx | (vertexColors at: idx) size = (faces at: idx) size]]
  "

   vertexColors := aCollection

  ! !

!B3DRegularSolid methodsFor: 'displaying' stamp: 'BG 9/9/2002 18:28'!
renderOn: aRenderer

 " it is not easy to write a fast method that correctly handles the presence or absence of all possible visual features.
Normally, is is not necessary to close the face polygons. In this code triangles *are* closed. When I did not close them, I noticed a crash of the VM. With closed triangles, all works as  it should. This observation indicates the presence of a bug somewhere in the renderer. "

 1 to: faces size do:
    [:idx |  | f vc |
        f := faces at: idx.
        aRenderer
	   trackEmissionColor: true.		"Turn on pre-lit colors"
        faceColors notNil
           ifTrue: [aRenderer color: (faceColors at: idx)].
        aRenderer normal: (faceNormals  at: idx).
        vertexColors notNil
           ifTrue:
             [vc := vertexColors at: idx.
              aRenderer
                drawPolygonAfter:
                  [1 to: f size do:
                       [:j | aRenderer normal: (faceNormals  at: idx).
                            aRenderer color: (vc at: j). 
                            aRenderer vertex: (vertices at: (f at: j))].
                   f size = 3
                     ifTrue: [aRenderer normal: (faceNormals  at: idx).
                               aRenderer color: (vc at: 1). 
                               aRenderer vertex: (vertices at: (f at: 1))]
            ]]
           ifFalse:
             [aRenderer
                drawPolygonAfter:
                  [1 to: f size do:
                       [:j | aRenderer normal: (faceNormals  at: idx).
                            aRenderer vertex: (vertices at: (f at: j))].
                   f size = 3
                     ifTrue: [aRenderer normal: (faceNormals  at: idx).
                               aRenderer color: (vc at: 1). 
                               aRenderer vertex: (vertices at: (f at: 1))]
            ]     ]
    ]! !

!B3DRegularSolid methodsFor: 'geometry' stamp: 'BG 8/29/2002 12:39'!
boundingBox
 "copied from B3DIndexMesh"
	^bBox ifNil:[bBox _ self computeBoundingBox]! !

!B3DRegularSolid methodsFor: 'geometry' stamp: 'BG 9/9/2002 10:26'!
normalForFace: vi 

  "  vi  is a collection of vertex indices. Only the first three vertices are used to compute the normal. For planar faces this is correct. "

  | v1 v2 v3 d1 d2 |
    v1 _ vertices at: (vi at: 1).
    v2 _ vertices at: (vi at: 2).
    v3 _ vertices at: (vi at: 3).
    d1 _ v3 - v1.
    d2 _ v2 - v1.
    d1 safelyNormalize.
    d2 safelyNormalize.
    ^(d1 cross: d2) safelyNormalize.! !

!B3DRegularSolid methodsFor: 'modifying' stamp: 'BG 9/5/2002 10:10'!
transformBy: aMatrix
  " this method assumes
     1. that vertices does not contain shared instances,
     2. that vertexNormals does not contain shared instances,
     3. that faceNormals does not contain shared instances. 
    Any shared instances would be transformed more than once, which is clearly wrong. "

	| transformer primVtx |
	transformer _ B3DPrimitiveTransformer new.
	primVtx _ B3DPrimitiveVertex new.
	vertices do:[:vtx|
		primVtx position: vtx.
		transformer privateTransformPrimitiveVertex: primVtx byModelView: aMatrix.
		vtx loadFrom: primVtx position].
	vertexNormals ifNotNil:[
		vertexNormals do:[:nrm|
			primVtx normal: nrm.
			transformer privateTransformPrimitiveNormal: primVtx byMatrix: aMatrix rescale: true.
			nrm loadFrom: primVtx normal]].
	faceNormals ifNotNil:[
		faceNormals do:[:nrm|
			primVtx normal: nrm.
			transformer privateTransformPrimitiveNormal: primVtx byMatrix: aMatrix rescale: true.
			nrm loadFrom: primVtx normal]].

	bBox _ self computeBoundingBox.
	"vtxNormals ifNil:[self computeVertexNormals]."! !

!B3DRegularSolid methodsFor: 'modifying' stamp: 'BG 9/9/2002 10:41'!
translateBy: amount

  " this method assumes
     1. that vertices does not contain shared instances,
    Any shared instances would be translated more than once, which is clearly wrong. "
  vertices do: [:vertex |   vertex += amount].
  bBox ifNotNil:[bBox _ bBox translateBy: amount].! !

!B3DRegularSolid methodsFor: 'private' stamp: 'BG 8/29/2002 12:39'!
computeBoundingBox
  " copied from B3DIndexedMesh"
	| min max |
	min _ max _ nil.
	vertices do:[:vtx|
		min ifNil:[min _ vtx] ifNotNil:[min _ min min: vtx].
		max ifNil:[max _ vtx] ifNotNil:[max _ max max: vtx].
	].
	^Rectangle origin: min corner: max! !

!B3DRegularSolid methodsFor: 'dodekahedron' stamp: 'BG 9/6/2002 11:36'!
computeEssentialPoints12

  " return the ten essential points of a dodecahedron.
    The solid is point symmetric to the origin of the coordinate system. It is therefore sufficient to compute 10 of its 20 vertices. The other vertices are obtained by multiplication with -1. "
   | points  |

   points := Array new: 10.
   1 to: 5 do: 
         [:idx |  
         points at: idx put: (B3DVector3
               x: (Float pi * (idx * 2 + 1) / 5) cos * 2
               y: (Float pi * (idx * 2 + 1) / 5) sin * 2
               z: 1.0 + 5.0 sqrt / 2 + 1.0).
         points at: idx + 5 put: (B3DVector3
               x: (Float pi * (idx * 2 + 1) / 5) cos * (1.0 + 5.0 sqrt)
               y: (Float pi * (idx * 2 + 1) / 5) sin * (1.0 + 5.0 sqrt)
               z: 1.0 + 5.0 sqrt / 2 - 1.0)].
   1 to: 10 do: [:idx | points at: idx put: (points at: idx)
            / (points at: idx) squaredLength sqrt * (0.81573786516665 / 0.79465447229177)].
   ^points
! !

!B3DRegularSolid methodsFor: 'dodekahedron' stamp: 'BG 9/9/2002 10:28'!
createDodekahedron

   | points |

  points := self computeEssentialPoints12.
  vertices := Array new: 20.
  1 to: points size do: 
     [:idx | vertices at: idx put: (points at: idx).
            vertices at: idx + 10 put: (points at: idx) negated].
  faces := OrderedCollection new: 12.
  faceNormals := OrderedCollection new: 12.
  faces add: (1 to: 5) asArray.
  faceNormals add: 
            (self normalForFace: (1 to: 5)).
  faces add: (11 to: 15) asArray.
  faceNormals add: 
            (self normalForFace: (11 to: 15)).
  
  1 to: 5 do:
     [:idx |  | a |
         a := Array with: idx 
                      with: idx + 5
                      with: idx + 2 \\ 5 + 1 + 5 + 10
                      with: idx \\ 5 + 1 + 5
                      with:  idx \\ 5 + 1.
         faces add: a.
         faceNormals add: (self normalForFace: a).
         a := Array with: idx + 10
                      with: idx + 5 + 10
                      with: idx + 2 \\ 5 + 1 + 5 
                      with: idx \\ 5 + 1 + 5 + 10
                      with:  idx \\ 5 + 1 + 10.
         faces add: a.
         faceNormals add: (self normalForFace: a).
     ].
   faces := faces asArray.

  
  
! !

!B3DRegularSolid methodsFor: 'icosahedron' stamp: 'BG 9/6/2002 11:36'!
computeEssentialPoints20

  " return the six essential points of a icosahedron. 
The solid is point symmetric to the origin of the coordinate system. It is therefore sufficient to compute 6 of its 12 vertices. The other vertices are obtained by multiplication with -1.  "
   | points  |

   points := Array new: 6.
   1 to: 5 do: 
         [:idx |  
         points at: idx put: (B3DVector3
               x: (Float pi * idx * 2 / 5) cos * 5.0 sqrt * 2 / 5
               y: (Float pi * idx * 2 / 5) sin * 5.0 sqrt * 2 / 5
               z: 5.0 sqrt / 5).
         ].
   points at: 6 put: (B3DVector3 x: 0.0 y: 0.0 z: 1.0).
   ^points
! !

!B3DRegularSolid methodsFor: 'icosahedron' stamp: 'BG 9/9/2002 10:29'!
createIcosahedron

   | points |

  points := self computeEssentialPoints20.
  vertices := Array new: 12.
  1 to: points size do: 
     [:idx | vertices at: idx put: (points at: idx).
            vertices at: idx + 6 put: (points at: idx) negated].

  faces := OrderedCollection new: 20.
  faceNormals := OrderedCollection new: 20.
	1 to: 5
		do: 
		  [ :idx |  | a |
              a := Array with: 6 with: idx with: idx \\ 5 + 1.
              faces add: a.
              faceNormals add: (self normalForFace: a).

              a := Array with: idx \\5 + 1 with: idx with: idx + 2 \\5 + 1 + 6.
              faces add: a.
              faceNormals add: (self normalForFace: a).

              a := Array with: idx + 6 with: idx \\5 + 1 + 6 with: idx + 2 \\5 + 1.
              faces add: a.
              faceNormals add: (self normalForFace: a).

              a := Array with: idx \\ 5 + 1 + 6 with: idx + 6 with: 12.
              faces add: a.
              faceNormals add: (self normalForFace: a).
           ].

  faces := faces asArray.! !

!B3DRegularSolid methodsFor: 'hexahedron' stamp: 'BG 9/9/2002 10:29'!
createHexahedron

    | sqrtFrom2 |

    sqrtFrom2 := 2.0 sqrt/ 2.0.
    vertices := OrderedCollection new: 8.
    vertices add: (B3DVector3 x: 1.0 y: 1.0 z: 1.0) * sqrtFrom2;
              add: (B3DVector3 x: -1.0 y: 1.0 z: 1.0) * sqrtFrom2;
              add: (B3DVector3 x: -1.0 y: -1.0 z: 1.0) * sqrtFrom2;
              add: (B3DVector3 x: 1.0 y: -1.0 z: 1.0) * sqrtFrom2;
              add: (B3DVector3 x: -1.0 y: -1.0 z: -1.0) * sqrtFrom2;
              add: (B3DVector3 x:  1.0 y: -1.0 z: -1.0) * sqrtFrom2;
              add: (B3DVector3 x:  1.0 y:  1.0 z: -1.0) * sqrtFrom2;
              add: (B3DVector3 x: -1.0 y:  1.0 z: -1.0) * sqrtFrom2.
    faces := OrderedCollection new: 6.
    faces add: #(1 2 3 4);
           add: #(1 4 6 7);
           add: #(1 7 8 2);
           add: #(2 8 5 3);
           add: #(5 8 7 6);
           add: #(3 5 6 4).
   faceNormals :=
         faces collect: [:f | self normalForFace: f].
   faces := faces asArray.! !

!B3DRegularSolid methodsFor: 'tetrahedron' stamp: 'BG 9/9/2002 10:29'!
createTetrahedron

    vertices := OrderedCollection new: 4.
    vertices add: (B3DVector3 x: 0.0 y: 0.0 z: 3.0 sqrt);
              add: (B3DVector3 x: 0.0 y: 6.0 sqrt * 2/3 z: 3.0 sqrt negated/ 3.0);
              add: (B3DVector3 x: 2.0 sqrt negated y: 6.0 sqrt negated/3  z: 3.0 sqrt negated/ 3.0);
              add: (B3DVector3 x: 2.0 sqrt y: 6.0 sqrt negated/3  z: 3.0 sqrt negated/ 3.0).
    faces := OrderedCollection new: 4.
    faces add: #(1 2 3);
           add: #(1 3 4);
           add: #(1 4 2);
           add: #(2 4 3).
   faceNormals :=
         faces collect: [:f | self normalForFace: f].
   faces := faces asArray.
! !

!B3DRegularSolid methodsFor: 'octahedron' stamp: 'BG 9/9/2002 10:29'!
createOctahedron

    | sqrtFrom2 |

    sqrtFrom2 := 2.0 sqrt.
    vertices := OrderedCollection new: 6.
    vertices add: (B3DVector3 x: 0.0 y: 0.0 z: sqrtFrom2);
              add: (B3DVector3 x: sqrtFrom2 y: 0.0 z: 0.0);
              add: (B3DVector3 x: 0.0 y: sqrtFrom2 z: 0.0);
              add: (B3DVector3 x: 0.0 y: 0.0 z: sqrtFrom2 negated);
              add: (B3DVector3 x: sqrtFrom2 negated y: 0.0 z: 0.0);
              add: (B3DVector3 x: 0.0 y: sqrtFrom2 negated z: 0.0).
    faces := OrderedCollection new: 8.
    faces add: #(1 2 3);
           add: #(1 3 5);
           add: #(1 5 6);
           add: #(1 6 2);
           add: #(2 6 4);
           add: #(2 4 3);
           add: #(4 6 5);
           add: #(3 4 5).
   faceNormals :=
         faces collect: [:f | self normalForFace: f].
   faces := faces asArray.
! !


!B3DRegularSolid class methodsFor: 'instance creation' stamp: 'BG 9/8/2002 14:41'!
cube

  ^self new createHexahedron! !

!B3DRegularSolid class methodsFor: 'instance creation' stamp: 'BG 9/6/2002 10:33'!
dodekahedron

  ^self new createDodekahedron! !

!B3DRegularSolid class methodsFor: 'instance creation' stamp: 'BG 9/8/2002 14:41'!
hexahedron

  ^self new createHexahedron! !

!B3DRegularSolid class methodsFor: 'instance creation' stamp: 'BG 9/6/2002 10:34'!
icosahedron

  ^self new createIcosahedron! !

!B3DRegularSolid class methodsFor: 'instance creation' stamp: 'BG 9/8/2002 10:21'!
octahedron

  ^self new createOctahedron! !

!B3DRegularSolid class methodsFor: 'instance creation' stamp: 'BG 9/8/2002 10:11'!
tetrahedron

  ^self new createTetrahedron! !


!B3DSimpleMeshFace methodsFor: 'rendering' stamp: 'BG 8/28/2002 22:06'!
renderOn: aRenderer
	^aRenderer trackEmissionColor: true;		"Turn on pre-lit colors"
			drawPolygonAfter:[
		aRenderer normal: self normal.
		1 to: self size do:[:i| (self at: i) renderOn: aRenderer].
	].! !


!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 9/4/2002 17:05'!
addFrameAndExplanationField

  | topView |

  topView := SystemWindow labelled: 'tutorial'.
  topView addMorph: self
            fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1.0 @ 0.8)).
  topView addMorph: (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0.8 corner: 1@1).
 ^topView! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 10:49'!
clearColor: aColor
  " set the background color of the B3DSceneMorph "
   b3DSceneMorph color: aColor! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 11:10'!
closeEnabled

  ^true! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 9/2/2002 10:19'!
codePaneMenu: aMenu shifted: shifted
	"Note that unless we override perform:orSendTo:, PluggableTextController will respond to all menu items in a text pane"
	| donorMenu |
	donorMenu _ shifted
		ifTrue:
			[ParagraphEditor shiftedYellowButtonMenu]
		ifFalse:
			[ParagraphEditor yellowButtonMenu].
	^ aMenu labels: donorMenu labelString lines: donorMenu lineArray selections: donorMenu selections! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 9/2/2002 10:16'!
contents
 ^source perform: textAccessor! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 9/2/2002 10:14'!
openInSystemWindow

  | topView |

  topView := SystemWindow labelled: 'tutorial'.
  topView addMorph: self
            fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1.0 @ 0.7)).
  topView addMorph: (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0.7 corner: 1@1).
  topView openInWorldExtent: 400 @ 500.! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 10:49'!
scene
	^b3DSceneMorph scene! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 8/25/2002 10:49'!
scene: aScene
	b3DSceneMorph scene: aScene.! !

!B3DTutorialScenePresenterMorph methodsFor: 'accessing' stamp: 'BG 9/2/2002 10:17'!
source: anInstance description: aSymbol

  source := anInstance.
  textAccessor := aSymbol.! !

!B3DTutorialScenePresenterMorph methodsFor: 'actions' stamp: 'BG 9/2/2002 15:49'!
acceptContents: xx

  ^true! !

!B3DTutorialScenePresenterMorph methodsFor: 'actions' stamp: 'BG 8/25/2002 11:14'!
closeMorph

  self delete! !

!B3DTutorialScenePresenterMorph methodsFor: 'actions' stamp: 'BG 8/25/2002 10:50'!
switchRotationStatus
	b3DSceneMorph switchRotationStatus! !

!B3DTutorialScenePresenterMorph methodsFor: 'change reporting' stamp: 'BG 8/25/2002 11:07'!
layoutChanged
	| ctrl |
	super layoutChanged.

	b3DSceneMorph ifNil: [^self].
	b3DSceneMorph extent: (self extent - ((frameWidth * 2)@(frameWidth * 2))).
	b3DSceneMorph position: (self bounds origin + ((frameWidth)@(frameWidth))).

	wheels ifNil: [^self].
	wheels isEmpty ifTrue: [^self].

	ctrl := wheels at: #fov ifAbsent: [nil].
	ctrl ifNotNil: [
		ctrl position:
			self bounds corner -
				ctrl extent - 
				(frameWidth@((frameWidth - ctrl extent y) / 2) rounded)].

	ctrl := wheels at: #dolly ifAbsent: [nil].
	ctrl ifNotNil: [
		ctrl position:
			self bounds corner -
				ctrl extent - 
				((((frameWidth - ctrl extent x) / 2) rounded)@frameWidth)].

	ctrl := wheels at: #rotX ifAbsent: [nil].
	ctrl ifNotNil: [
		ctrl position:
			(self bounds origin x + (((frameWidth - ctrl extent x) / 2) rounded))@(self bounds corner y - ctrl extent y - frameWidth)].

	ctrl := wheels at: #rotY ifAbsent: [nil].
	ctrl ifNotNil: [
		ctrl position:
			(self bounds origin x + frameWidth)@(self bounds corner y - ctrl extent y - (((frameWidth - ctrl extent y) / 2) rounded))].

	ctrl := wheels at: #rotZ ifAbsent: [nil].
	ctrl ifNotNil: [
		ctrl position:
			self bounds origin +
			((((frameWidth - ctrl extent x) / 2) rounded)@frameWidth)].

	ctrl := wheels at: #accel ifAbsent:[nil].
	ctrl ifNotNil:[
		ctrl position:
			self bounds origin +
			(frameWidth @ ((((frameWidth - ctrl extent y) / 2) rounded)))].

	ctrl := wheels at: #accel ifAbsent:[nil].
	ctrl ifNotNil:[
		ctrl position:
			self bounds origin +
			(frameWidth @ ((((frameWidth - ctrl extent y) / 2) rounded)))].
! !

!B3DTutorialScenePresenterMorph methodsFor: 'drawing' stamp: 'BG 8/25/2002 10:52'!
drawOn: aCanvas
	"Don't fill if my b3dScene does it"
	(b3DSceneMorph notNil and:[b3DSceneMorph color isOpaque]) ifTrue:[
		(aCanvas clipRect areasOutside: b3DSceneMorph bounds) do:[:r|
			aCanvas clipBy: r during:[:cc| super drawOn: cc].
		].
	] ifFalse: [super drawOn: aCanvas].! !

!B3DTutorialScenePresenterMorph methodsFor: 'event handling' stamp: 'BG 8/25/2002 10:53'!
handlesMouseDown: evt
	^evt yellowButtonPressed
! !

!B3DTutorialScenePresenterMorph methodsFor: 'event handling' stamp: 'BG 8/25/2002 10:53'!
mouseDown: evt
	evt yellowButtonPressed ifTrue: [
		self yellowButtonMenu.
		^super mouseDown: evt].! !

!B3DTutorialScenePresenterMorph methodsFor: 'initialization' stamp: 'BG 8/25/2002 11:10'!
closeButton
	| outerButton aButton str miniWrapper aHelp |
	outerButton _ AlignmentMorph newRow height: 24.
	outerButton beTransparent.
	outerButton hResizing: #spaceFill; vResizing: #shrinkWrap.
	outerButton addMorph: (aButton _ UpdatingThreePhaseButtonMorph checkBox).
	aButton
		target: self;
		actionSelector: #closeMorph;
		arguments: #();
		getSelector: #closeEnabled.

	outerButton addTransparentSpacerOfSize: (2 @ 0).
	str _ StringMorph contents: 'close' font: nil. "(StrikeFont familyName: 'NewYork' size: 12)."
	miniWrapper _ AlignmentMorph newRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	miniWrapper beTransparent addMorphBack: str lock.
	outerButton addMorphBack: miniWrapper.
	aButton setBalloonText: (aHelp _ 'Turn on hardware acceleration if supported').
	miniWrapper setBalloonText: aHelp; setProperty: #balloonTarget toValue: aButton.
	^outerButton! !

!B3DTutorialScenePresenterMorph methodsFor: 'menus' stamp: 'BG 8/25/2002 10:55'!
addCustomMenuItems: aCustomMenu

	(aCustomMenu isKindOf: MenuMorph)
		ifTrue: [aCustomMenu addUpdating: #rotationString action: #switchRotationStatus]
		ifFalse: [aCustomMenu add: 'swich rotation status' action: #switchRotationStatus].
! !

!B3DTutorialScenePresenterMorph methodsFor: 'menus' stamp: 'BG 8/25/2002 10:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu addLine.
	self addCustomMenuItems: aCustomMenu.
! !

!B3DTutorialScenePresenterMorph methodsFor: 'menus' stamp: 'BG 9/2/2002 12:16'!
initialize
	| ctrl |
	super initialize.
	color := Color gray: 0.8.
	frameWidth := 25.

	b3DSceneMorph := AdvancedB3DScenePresenterMorph new.
	b3DSceneMorph color: Color white;
                     borderStyle: (BorderStyle width: 1 color: Color black).
	self addMorphFront: b3DSceneMorph.
	
	wheels := Dictionary new.
	ctrl := WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #addFovAngle:.
	ctrl factor: -0.07.
	ctrl setBalloonText: 'FOV'.
	self addMorphFront: ctrl.
	wheels at: #fov put: ctrl.

	ctrl := WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #addDolly:.
	ctrl factor: 0.005.
	ctrl beVertical.
	ctrl setBalloonText: 'Dolly'.
	self addMorphFront: ctrl.
	wheels at: #dolly put: ctrl.

	ctrl := WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #rotateZ:.
	ctrl beVertical.
	ctrl setBalloonText: 'z Axis'.
	self addMorphFront: ctrl.
	wheels at: #rotZ put: ctrl.

	ctrl := WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #rotateY:.
	ctrl setBalloonText: 'y Axis'.
	self addMorphFront: ctrl.
	wheels at: #rotY put: ctrl.

	ctrl := WheelMorph new.
	ctrl target: b3DSceneMorph.
	ctrl actionSelector: #rotateX:.
	ctrl beVertical.
	ctrl setBalloonText: 'x Axis'.
	self addMorphFront: ctrl.
	wheels at: #rotX put: ctrl.

"
	ctrl _ self closeButton.
	self addMorphFront: ctrl.
	wheels at: #accel put: ctrl.  "


! !

!B3DTutorialScenePresenterMorph methodsFor: 'menus' stamp: 'BG 8/25/2002 10:54'!
rotationString
	^b3DSceneMorph isRotating
		ifTrue: ['stop rotating']
		ifFalse: ['start rotating']! !

!B3DTutorialScenePresenterMorph methodsFor: 'menus' stamp: 'BG 8/25/2002 10:54'!
yellowButtonMenu
	| menu sel |
	menu _ CustomMenu new.
	menu title: self class name.
	self addCustomMenuItems: menu.
	sel := menu startUp.
	sel ifNotNil: [self perform: sel]! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 10:55'!
addDolly: a

   b3DSceneMorph addDolly: a! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 14:11'!
beRotating

   b3DSceneMorph beRotating! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 10:55'!
defaultColor
	^Color gray! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 10:56'!
panBy: a

   b3DSceneMorph panBy: a! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 10:56'!
rotateX: a

   b3DSceneMorph rotateX: a! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 10:56'!
rotateY: a

   b3DSceneMorph rotateY: a! !

!B3DTutorialScenePresenterMorph methodsFor: 'visual properties' stamp: 'BG 8/25/2002 10:56'!
rotateZ: a

   b3DSceneMorph rotateZ: a! !


!B3DTutorialScenePresenterMorph class methodsFor: 'initialization' stamp: 'BG 8/25/2002 09:44'!
descriptionForPartsBin
	^ self partName:	'Explore3D'
		categories:		#('3-D')
		documentation:	'A place where you can explore with a rotating 3-D object'! !


!TutorialPresenter class methodsFor: 'instance creation' stamp: 'BG 9/2/2002 09:48'!
openAsMorph
  " TutorialPresenter openAsMorph "

   | model topView diagramView explanationView |

  topView := (SystemWindow labelled: 'Tutorial Presenter') model: (model := self new).
  diagramView := B3DTutorialScenePresenterMorph new.
  topView addMorph: diagramView
            fullFrame: (LayoutFrame fractions: (0@0 corner: 1.0@1.0) ).

  topView openInWorldExtent: 500 @500! !

TutorialPresenter removeSelector: #initialExtent!

!B3DTutorialScenePresenterMorph reorganize!
('accessing' addFrameAndExplanationField clearColor: closeEnabled codePaneMenu:shifted: contents openInSystemWindow scene scene: source:description:)
('actions' acceptContents: closeMorph switchRotationStatus)
('change reporting' layoutChanged)
('drawing' drawOn:)
('event handling' handlesMouseDown: mouseDown:)
('initialization' closeButton)
('menus' addCustomMenuItems: addCustomMenuItems:hand: initialize rotationString yellowButtonMenu)
('visual properties' addDolly: beRotating defaultColor panBy: rotateX: rotateY: rotateZ:)
!

B3DDemoSurfaces removeSelector: #createTriangleGeometry:withDerivatives:and:!
B3DDemoSpheres removeSelector: #description!
B3DDemoSpheres removeSelector: #show!

!B3DDemoSpheres reorganize!
('common methods' colorTilesWith:and: gradientTexture gradientTextureForSphere gradientTextureForSphere2)
('demo1' createScene1 descriptionScene1 show1)
('demo2' createScene2 descriptionScene2 show2)
('demo3' createLightsForScene3: createScene3 createSolidsForScene3: descriptionScene3 show3)
('demo4' createLightsForScene4: createScene4 createSolidsForScene4: descriptionScene4 show4)
('demo4a' createLightsForScene4a: createScene4a createSolidsForScene4a: descriptionScene4a show4a)
('demo5' createLightsForScene5: createScene5 createSolidsForScene5: descriptionScene5 show5)
('demo6' createLightsForScene6: createScene6 createSolidsForScene6: descriptionScene6 show6)
('demo6a' createLightsForScene6a: createScene6a createSolidsForScene6a: descriptionScene6a show6a)
('demo7' createLightsForScene7: createScene7 createSolidsForScene7: descriptionScene7 show7)
('demo8' createLightsForScene8: createScene8 createSolidsForScene8: descriptionScene8 show8)
('demo9' createLightsForScene9: createScene9 createSolidsForScene9: descriptionScene9 show9)
('demo10' createLightsForScene10: createScene10 createSolidsForScene10: descriptionScene10 show10)
!


!B3DDemoSolids reorganize!
('common methods' createBody createBodyWithFaceColors:)
('demo1' createLightsForScene1: createScene1 createSolidsForScene1: descriptionScene1 show1)
('demo2' createLightsForScene2: createScene2 descriptionScene2 show2)
('demo3' createLightsForScene3: createScene3 createSolidsForScene3: descriptionScene3 show3)
('demo4' createScene4 createSolidsForScene4: descriptionScene4 show4)
('demo5' createLightsForScene5: createScene5 createSolidsForScene5: descriptionScene5 show5)
('demo6' createLightsForScene6: createScene6 createSolidsForScene6: descriptionScene6 show6)
('demo7' createScene7 createSolidsForScene7: descriptionScene7 show7)
('demo8' createScene8 createSolidsForScene8: descriptionScene8 show8)
!

B3DDemoBlockWorld removeSelector: #createScene9!

!AdvancedB3DScenePresenterMorph reorganize!
('accessing' rotationAngle rotationAngle: scene: stepTime stepTime:)
('camera actions' addDolly: addFovAngle: panBy: rotateFrom:to: rotateX: rotateY: rotateZ: transformWithMatrix:)
('drawing' renderOn:)
('event handling' handlesMouseDown: mouseDown: mouseMove:)
('initialization' createDefaultScene initialize)
('properties' beRotating beStill isRotating switchRotationStatus)
('stepping' step)
('private' pointOnSphereCentered:radius:atPoint: updateUpVectorForCamera:)
!

